-- Add a field to the chat frames
CHAT_MSG_CTRAID = "CTRaid";
ChatTypeGroup["CTRAID"] = {
	"CHAT_MSG_CTRAID"
};
ChatTypeInfo["CTRAID"] = { sticky = 0 };
OtherMenuChatTypeGroups[4] = "CTRAID";
CHAT_CTRAID_GET = "";
CT_RA_ChatInfo = {
	["Default"] = {
		["r"] = 1.0,
		["g"] = 0.5,
		["b"] = 0,
		["show"] = {
			"ChatFrame1"
		}
	}
};
CT_RA_LastSent = { };
CT_RA_BuffTimeLeft = { };

CT_oldFCF_Tab_OnClick = FCF_Tab_OnClick;
function CT_newFCF_Tab_OnClick(button)
	CT_oldFCF_Tab_OnClick(button);
	if ( button == "RightButton" ) then
		local frame = getglobal("ChatFrame" .. this:GetID());
		local info = CT_RA_ChatInfo["Default"];
		if ( CT_RA_ChatInfo[UnitName("player")] ) then
			info = CT_RA_ChatInfo[UnitName("player")];
		end
		for k, v in info["show"] do
			if ( v == "ChatFrame" .. this:GetID() ) then
				local y = 1;
				while ( frame.messageTypeList[y] ) do
					y = y + 1;
				end
				frame.messageTypeList[y] = "CTRAID";
			end
		end
	end
end
FCF_Tab_OnClick = CT_newFCF_Tab_OnClick;

CT_oldFCF_SetChatTypeColor = FCF_SetChatTypeColor;
function CT_newFCF_SetChatTypeColor()
	CT_oldFCF_SetChatTypeColor();
	if ( UIDROPDOWNMENU_MENU_VALUE == "CTRAID" ) then
		local r,g,b = ColorPickerFrame:GetColorRGB();
		if ( not CT_RA_ChatInfo[UnitName("player")] ) then
			CT_RA_ChatInfo[UnitName("player")] = CT_RA_ChatInfo["Default"];
		end
		CT_RA_ChatInfo[UnitName("player")].r = r;
		CT_RA_ChatInfo[UnitName("player")].g = g;
		CT_RA_ChatInfo[UnitName("player")].b = b;
		ChatTypeInfo["CTRAID"].r = r;
		ChatTypeInfo["CTRAID"].g = g;
		ChatTypeInfo["CTRAID"].b = b;
	end
end
FCF_SetChatTypeColor = CT_newFCF_SetChatTypeColor;

CT_oldFCF_CancelFontColorSettings = FCF_CancelFontColorSettings;
function CT_newFCF_CancelFontColorSettings(prev)
	CT_oldFCF_CancelFontColorSettings(prev);
	if ( prev.r and UIDROPDOWNMENU_MENU_VALUE == "CTRAID" ) then
		if ( not CT_RA_ChatInfo[UnitName("player")] ) then
			CT_RA_ChatInfo[UnitName("player")] = CT_RA_ChatInfo["Default"];
		end
		CT_RA_ChatInfo[UnitName("player")].r = prev.r;
		CT_RA_ChatInfo[UnitName("player")].g = prev.g;
		CT_RA_ChatInfo[UnitName("player")].b = prev.b;
		ChatTypeInfo["CTRAID"].r = prev.r;
		ChatTypeInfo["CTRAID"].g = prev.g;
		ChatTypeInfo["CTRAID"].b = prev.b;
	end
end
FCF_CancelFontColorSettings = CT_newFCF_CancelFontColorSettings;
CT_oldFCFMessageTypeDropDown_OnClick = FCFMessageTypeDropDown_OnClick;
function CT_newFCFMessageTypeDropDown_OnClick()
	CT_oldFCFMessageTypeDropDown_OnClick();
	if ( not CT_RA_ChatInfo[UnitName("player")] ) then
		CT_RA_ChatInfo[UnitName("player")] = CT_RA_ChatInfo["Default"];
	end
	if ( this.value == "CTRAID" ) then
		if ( UIDropDownMenuButton_GetChecked() ) then
			for k, v in CT_RA_ChatInfo[UnitName("player")]["show"] do
				if ( v == FCF_GetCurrentChatFrame():GetName() ) then
					CT_RA_ChatInfo[UnitName("player")]["show"][k] = nil;
					break;
				end
			end
		else
			tinsert(CT_RA_ChatInfo[UnitName("player")]["show"], FCF_GetCurrentChatFrame():GetName());
		end
	end
end
FCFMessageTypeDropDown_OnClick = CT_newFCFMessageTypeDropDown_OnClick;

CT_RA_ShowGroups = { };
CT_RA_Channel = nil;
CT_RA_Level = 0;
CT_RA_AllowedCommanders = 1;
CT_RA_Stats = {
	{
		{ }
	}
};
CT_RA_BuffsToCure = { };
CT_RA_BuffsToRecast = { };
CT_RA_MainTankStats = { };
CT_RA_RaidParticipant = nil; -- Used to see what player participated in the raid on this account

CT_RA_Auras = { 
	["buffs"] = { },
	["debuffs"] = { }
};
CT_RA_LastSend = nil;
CT_RA_DebuffColors = {
	{ ["type"] = "Curse", ["r"] = 1, ["g"] = 0, ["b"] = 0.75, ["a"] = 0.5, ["id"] = 4 },
	{ ["type"] = "Magic", ["r"] = 1, ["g"] = 0, ["b"] = 0, ["a"] = 0.5, ["id"] = 6 },

	{ ["type"] = "Poison", ["r"] = 0, ["g"] = 0.5, ["b"] = 0, ["a"] = 0.5, ["id"] = 3 },
	{ ["type"] = "Disease", ["g"] = 1, ["b"] = 0, ["a"] = 0.5, ["id"] = 5 },
	{ ["type"] = "Weakened_Soul", ["r"] = 1, ["g"] = 0, ["b"] = 1, ["a"] = 0.5, ["id"] = 2 },
	{ ["type"] = "Recently_Bandaged", ["r"] = 0, ["g"] = 0, ["b"] = 0, ["a"] = 0.5, ["id"] = 1 }
};
CT_RA_ClassPositions = {
	["Warrior"] = 1,
	["Druid"] = 2,
	["Mage"] = 3,
	["Warlock"] = 4,
	["Rogue"] = 5,
	["Hunter"] = 6,
	["Priest"] = 7,
	["Paladin"] = 8,
	["Shaman"] = 8
};

CT_RA_HiddenGroups = nil; -- Used by Hide/Show all windows
CT_RA_NumRaidMembers = 0;

function CT_RA_ShowHideWindows()
	if ( CT_RA_HiddenGroups ) then
		CT_RA_ShowGroups = CT_RA_HiddenGroups;
		CT_RA_HiddenGroups = nil;

		local num = 0;
		for k, v in CT_RA_ShowGroups do
			num = num + 1;
			getglobal("CT_RAOptionsGroupCB" .. k):SetChecked(1);
		end
		if ( num > 0 ) then
			CT_RACheckAllGroups:SetChecked(1);
		else
			CT_RACheckAllGroups:SetChecked(nil);
		end
	else
		CT_RA_HiddenGroups = CT_RA_ShowGroups;
		CT_RA_ShowGroups = { };
		for i = 1, 8, 1 do
			getglobal("CT_RAOptionsGroupCB" .. i):SetChecked(nil);
		end
		CT_RACheckAllGroups:SetChecked(nil);
	end
	CT_RA_UpdateRaidGroup();
end

function CT_RA_SetGroup()
	CT_RA_ShowGroups[this:GetID()] = this:GetChecked();
	local num = 0;
	for k, v in CT_RA_ShowGroups do
		num = num + 1;
	end
	if ( num > 0 ) then
		CT_RACheckAllGroups:SetChecked(1);
	else
		CT_RACheckAllGroups:SetChecked(nil);
	end
	CT_RA_UpdateRaidGroup();
end

function CT_RA_CheckAllGroups()
	if ( not CT_RA_ShowGroups ) then CT_RA_ShowGroups = { }; end
	for i = 1, 8, 1 do
		CT_RA_ShowGroups[i] = this:GetChecked();
		getglobal("CT_RAOptionsGroupCB" .. i):SetChecked(this:GetChecked());
	end
	CT_RA_UpdateRaidGroup();
end

function CT_RA_ParseEvent(event)
	if ( strsub(event, 1, 13) == "CHAT_MSG_RAID" ) then
		local useless, useless, chan = string.find(gsub(arg1, "%%", "%%%%"), "<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: (.+)");
		if ( chan ) then
			for i = 1, GetNumRaidMembers(), 1 do
				local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
				if ( rank >= 1 and name == arg2 ) then
					CT_RA_Channel = chan;
					CT_RA_Print("The CT_RaidAssist channel has been changed to '|c00FFFFFF" .. chan .. "|r. Type |c00FFFFFF/raidassist join|r to join this channel.", 1, 0.5, 0);
				end
			end
		end

	elseif ( event == "CHAT_MSG_WHISPER" ) then
		if ( CT_RA_KeyWord and arg1 == CT_RA_KeyWord ) then
			local temp = arg2;
			CT_RA_Print("<CTMod> Invited '|c00FFFFFF" .. arg2 .. "|r' by Keyword Inviting.", 1, 0.5, 0);
			InviteByName(temp);
		end

	elseif ( strsub(event, 1, 15) == "CHAT_MSG_SYSTEM" ) then
		local useless, useless, plr = string.find(arg1, "^([^%s]+) has left the raid group$");
		if ( plr ) then
			CT_RA_Stats[plr] = nil;
			for k, v in CT_RA_MainTanks do
				if ( v == plr ) then
					CT_RA_MainTanks[k] = nil;
					CT_RA_MainTankStats[k] = nil;
					break;
				end
			end
			CT_RA_UpdateRaidGroup();
			CT_RA_UpdateMTs();
			CT_RAOptions_Update();
		end

	elseif ( event == "CHAT_MSG_CHANNEL" and CT_RA_Channel and arg9 and strlower(arg9) == strlower(CT_RA_Channel) ) then
		local type = strsub(event, 10);
		local info = ChatTypeInfo[type];
		event = "CHAT_MSG_CTRAID";
		for i = 1, GetNumRaidMembers(), 1 do
			local name = GetRaidRosterInfo(i);
			local message, update;
			if ( name == arg2 ) then
				arg1 = gsub(arg1, "%%", "%%%%");
				local msg = string.gsub(arg1, "%$", "s");
				msg = string.gsub(msg, "", "S");
				if ( strsub(msg, strlen(msg)-7) == " ...hic!") then
					msg = strsub(msg, 1, strlen(msg)-8);
				end
				if ( string.find(msg, "#") ) then
					local arr = CT_RA_Split(msg, "#");
					for k, v in arr do
						local temp, message = CT_RA_ParseMessage(arg2, v);
						if ( temp ) then
							update = 1;
						end
						if ( message ) then
							CT_RA_Print(message, 1, 0.5, 0);
						end
					end
				else
					update, message = CT_RA_ParseMessage(arg2, msg);
					if ( message ) then
						CT_RA_Print(message, 1, 0.5, 0);
					end
				end

				CT_RA_UpdateUnit(arg2);
				if ( update ) then
					CT_RA_UpdateRaidGroup();
					CT_RA_UpdateMTs();
				end
				break;
			end
		end
	end
end
	
CT_RA_oldChatFrame_OnEvent = ChatFrame_OnEvent;
function CT_RA_newChatFrame_OnEvent(event)

	if ( strsub(event, 1, 13) == "CHAT_MSG_RAID" ) then
		local useless, useless, chan = string.find(gsub(arg1, "%%", "%%%%"), "^<CTMod> This is an automatic message sent by CT_RaidAssist. Channel changed to: (.+)$");
		if ( chan ) then
			return;
		end
	end

	if ( event == "CHAT_MSG_WHISPER" ) then
		if ( CT_RA_KeyWord and arg1 == CT_RA_KeyWord ) then
			return;
		end
	end

	-- There is a channel
	if ( strsub(event, 1, 8) == "CHAT_MSG" and CT_RA_Channel and arg9 and strlower(arg9) == strlower(CT_RA_Channel) ) then
		local type = strsub(event, 10);
		local info = ChatTypeInfo[type];
		if ( type ~= "CHANNEL_LIST" and type ~= "SYSTEM" ) then
			return;
		end
	end
	CT_RA_oldChatFrame_OnEvent(event);
end
ChatFrame_OnEvent = CT_RA_newChatFrame_OnEvent;

function CT_RA_ParseMessage(nick, msg)
	local useless, useless, val1, val2, val3, val4, update;

	if ( not CT_RA_Stats[nick] ) then
		CT_RA_Stats[nick] = {
			["Health"] = nil,
			["Healthmax"] = nil,
			["Mana"] = nil,
			["Buffs"] = { },
			["Debuffs"] = { },
			["Position"] = { }
		};
		update = 1;
		-- Flag for updating after processing
	end
	
	-- Check health
	useless, useless, val1, val2 = string.find(msg, "^H ([^%s]+) ([^%s]+)$");
	if ( tonumber(val1) and tonumber(val2) ) then
		-- Health
		CT_RA_Stats[nick]["Health"] = floor(tonumber(val1));
		CT_RA_Stats[nick]["Healthmax"] = tonumber(val2);
		return update;
	end
	
	-- Check health (backwards compatibility)
	useless, useless, val1 = string.find(msg, "^H ([^%s]+)$");
	if ( tonumber(val1) ) then
		-- Health
		CT_RA_Stats[nick]["Health"] = floor(tonumber(val1));
		return update;
	end

	-- Check mana
	useless, useless, val1 = string.find(msg, "^M (%d+)$");
	if ( val1 ) then
		-- Mana
		CT_RA_Stats[nick]["Mana"] = tonumber(val1);
		return update;
	end
	
	-- Check buffs
	useless, useless, val1, val2, val3 = string.find(msg, "^B ([^%s]+) ([^%s]+) (.+)$");
	if ( val1 ) then
		-- Buffs
		CT_RA_Stats[nick]["Buffs"][val3] = { val1, tonumber(val2) };
		return update;
	end

	-- Check buff expiration
	useless, useless, val1 = string.find(msg, "^BE (.+)$");
	if ( val1 ) then
		CT_RA_Stats[nick]["Buffs"][val1] = nil;
		-- Buff expired
		if ( CT_RA_NotifyBuffs["main"] and val1 ~= "Power Word: Shield" and val1 ~= "Fire Shield" and val1 ~= "Admiral's Hat") then
			for k, v in CT_RA_BuffArray do
				if ( v["name"] == val1 and v["show"] ~= -1 ) then
					for key, val in CT_RA_CurrPositions do
						local name = GetRaidRosterInfo(key);
						if ( name == nick and CT_RA_NotifyBuffs[val] ) then
							if ( CT_RA_ClassSpells and CT_RA_ClassSpells[val1] and GetBindingKey("CT_RECASTRAIDBUFF") ) then
								if ( GetBindingKey("CT_RECASTRAIDBUFF") ) then
									CT_RA_AddToBuffQueue(val1, nick);
									return 1, "<CTMod> '|c00FFFFFF" .. nick .. "|r's '|c00FFFFFF" .. val1 .. "|r' has faded. Press '|c00FFFFFF" .. KeyBindingFrame_GetLocalizedName(GetBindingKey("CT_RECASTRAIDBUFF"), "KEY_") .. "|r' to recast.";
								else
									return 1, "<CTMod> '|c00FFFFFF" .. nick .. "|r's '|c00FFFFFF" .. val1 .. "|r' has faded.";
								end
							end
							break;
						end
					end
				end
			end
		end
		return update;
	end

	-- Check debuffs
	useless, useless, val3, val4, val1, val2 = string.find(msg, "^D ([^%s]+) ([^%s]+) ([%a_]+) (.+)$");
	if ( val1 and val2 and val3 and val4 ) then
		-- Debuff
		CT_RA_Stats[nick]["Debuffs"][val2] = { val1, tonumber(val3), val4 };
		if ( CT_RA_NotifyDebuffs["main"] ) then
			for k, v in CT_RA_DebuffColors do
				if ( v["type"] == val1 and v["id"] ~= -1 ) then
					for key, val in CT_RA_CurrPositions do
						local name = GetRaidRosterInfo(key);
						if ( name == nick and CT_RA_NotifyDebuffs[val] ) then
							if ( not CT_RA_HideShort or tonumber(val3) >= 10 ) then
								local postfix = " (|c00FFFFFF" .. string.gsub(val1, "_", " ") .. "|r)";
								if ( string.gsub(val1, "_", " ") == val2 ) then
									postfix = "";
								end
								if ( CT_RA_ClassSpells and GetBindingKey("CT_CUREDEBUFF") and CT_RA_GetCure(v["type"]) ) then
									CT_RA_AddToQueue(v["type"], nick, string.gsub(val1, "_", " "));
									return 1, "<CTMod> '|c00FFFFFF" .. nick .. "|r' has been debuffed by '|c00FFFFFF" .. val2 .. "|r'" .. postfix .. ". Press '|c00FFFFFF" .. KeyBindingFrame_GetLocalizedName(GetBindingKey("CT_CUREDEBUFF"), "KEY_") .. "|r' to cure.";
								else
									return 1, "<CTMod> '|c00FFFFFF" .. nick .. "|r' has been debuffed by '|c00FFFFFF" .. val2 .. "|r'" .. postfix .. ".";
								end
							end
							break;
						end
					end
				end
			end
		end
		return update;
	end

	-- Check debuff expiration
	useless, useless, val1 = string.find(msg, "^DE (.+)$");
	if ( val1 ) then
		-- Debuff expired
		CT_RA_Stats[nick]["Debuffs"][val1] = nil;
		return update;
	end

	-- Check status requests
	if ( msg == "SR" ) then
		for i = 1, GetNumRaidMembers(), 1 do
			local name, rank = GetRaidRosterInfo(i);
			if ( rank >= 1 and name == nick ) then
				CT_RA_SendStatus();
				break;
			end
		end
		return update;
	end

	if ( strsub(msg, 1, 2) == "S " ) then
		for str in string.gfind(msg, " B [^%s]+ [^%s]+ [^#]+ #") do
			useless, useless, val1, val3, val2 = string.find(str, "B ([^%s]+) ([^%s]+) (.+) #");
			CT_RA_Stats[nick]["Buffs"][val2] = { val1, tonumber(val3) };
		end
	end

	if ( strsub(msg, 1, 3) == "MS " ) then
		for i = 1, GetNumRaidMembers(), 1 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if ( rank >= 1 and name == nick ) then
				CT_RAMessageFrame:AddMessage(nick .. ": " .. strsub(msg, 3), CT_RA_DefaultAlertColor.r,CT_RA_DefaultAlertColor.g, CT_RA_DefaultAlertColor.b, 1.0, UIERRORS_HOLD_TIME);
				return update;
			end
		end
	end

	if ( strsub(msg, 1, 4) == "SET " ) then
		local useless, useless, num, name = string.find(msg, "^SET (%d) (.+)$");
		if ( num and name ) then
			for i = 1, GetNumRaidMembers(), 1 do
				local user, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
				if ( rank >= 1 and user == nick ) then
					for k, v in CT_RA_MainTanks do
						if ( v == name ) then
							CT_RA_MainTanks[k] = nil;
						end
					end
					CT_RA_MainTanks[tonumber(num)] = name;
					CT_RAOptions_Update();
					return update;
				end
			end
		end
	end

	if ( strsub(msg, 1, 2) == "R " ) then
		local useless, useless, name = string.find(msg, "^R (.+)$");
		if ( name ) then
			for k, v in CT_RA_MainTanks do
				if ( v == name ) then
					for i = 1, GetNumRaidMembers(), 1 do
						local user, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
						if ( rank >= 1 and user == nick ) then
							CT_RA_MainTanks[k] = nil;
							CT_RA_UpdateMTs();
							CT_RAOptions_Update();
							return update;
						end
					end
				end
			end
		end
		update = 1;
	end

	if ( strsub(msg, 1, 3) == "MT " ) then
		local useless, useless, id, type, percent = string.find(msg, "^MT ([^%s]+) (.) (%d+)$");
		if ( id and type and percent ) then
			id = tonumber(id);
			percent = tonumber(percent);
			if ( CT_RA_MainTanks[id] == nick ) then
				if ( not CT_RA_MainTankStats[id] ) then return; end

				if ( type == "H" ) then
					CT_RA_MainTankStats[id]["health"] = percent;
				elseif ( type == "M" ) then
					CT_RA_MainTankStats[id]["mana"] = percent;
				end
			end
		end
		update = 1;
	end
	if ( strsub(msg, 1, 3) == "TC " ) then
		local useless, useless, id, hasmana, friend, health, mana, name = string.find(msg, "^TC (%d) (%d) (%d) ([^%s]+) ([^%s]+) (.+)$");
		if ( id and hasmana and friend and health and mana and name and CT_RA_MainTanks[tonumber(id)] == nick ) then
			id = tonumber(id);
			friend = tonumber(friend);
			health = tonumber(health);
			mana = tonumber(mana);
			hasmana = tonumber(hasmana);
			CT_RA_MainTankStats[id] = { };
			CT_RA_MainTankStats[id]["hasmana"] = hasmana;
			CT_RA_MainTankStats[id]["friend"] = friend;
			CT_RA_MainTankStats[id]["name"] = name;
			CT_RA_MainTankStats[id]["health"] = health;
			if ( mana ~= -1 ) then
				CT_RA_MainTankStats[id]["mana"] = mana;
			end
			update = 1;
		end
	end

	if ( strsub(msg, 1, 3) == "LT " ) then
		local id = strsub(msg, 4);
		if ( tonumber(id) and CT_RA_MainTanks[tonumber(id)] == nick ) then
			CT_RA_MainTankStats[tonumber(id)] = nil;
		end
		update = 1;
	end
	
	if ( strsub(msg, 1, 2) == "P " ) then
		local useless, useless, hp, max, mana = string.find(msg, "^P ([^%s]+) ([^%s]+) (%d+)$");
		if ( tonumber(hp) and tonumber(mana) and tonumber(max)) then
			CT_RA_Stats[nick]["Health"] = floor(tonumber(hp));
			CT_RA_Stats[nick]["Healthmax"] = tonumber(max);
			CT_RA_Stats[nick]["Mana"] = tonumber(mana);
		else
			-- Backwards compatibility
			local useless, useless, hp, mana = string.find(msg, "^P ([^%s]+) (%d+)$");
			if ( tonumber(hp) and tonumber(mana)) then
				CT_RA_Stats[nick]["Health"] = floor(tonumber(hp));
				CT_RA_Stats[nick]["Mana"] = tonumber(mana);
			end
		end
	end

	if ( strsub(msg, 1, 3) == "PH " ) then
		local useless, useless, player, val, max = string.find(msg, "^P. ([^%s]+) ([^%s]+) ([^%s]+)$");
		if ( player and tonumber(val) and tonumber(max) ) then
			if ( not CT_RA_Stats[player] ) then
				CT_RA_Stats[player] = {
					["Health"] = nil,
					["Mana"] = nil,
					["Buffs"] = { },
					["Debuffs"] = { },
					["Position"] = { }
				};
				update = 1;
			end
			CT_RA_Stats[player]["Health"] = floor(tonumber(val));
			CT_RA_Stats[player]["Healthmax"] = tonumber(max);
			CT_RA_UpdateUnit(player);
		else
			-- Backwards compatibility
			local useless, useless, player, val, max = string.find(msg, "^P. ([^%s]+) ([^%s]+)$");
			if ( player and tonumber(val) ) then
				if ( not CT_RA_Stats[player] ) then
					CT_RA_Stats[player] = {
						["Health"] = nil,
						["Mana"] = nil,
						["Buffs"] = { },
						["Debuffs"] = { },
						["Position"] = { }
					};
					update = 1;
				end
				CT_RA_Stats[player]["Health"] = floor(tonumber(val));
				CT_RA_UpdateUnit(player);
			end
		end
	end
	if ( strsub(msg, 1, 3) == "PM " ) then
		local useless, useless, player, val = string.find(msg, "^P. ([^%s]+) ([^%s]+)$");
		if ( player and tonumber(val) ) then
			if ( not CT_RA_Stats[player] ) then
				CT_RA_Stats[player] = {
					["Health"] = nil,
					["Healthmax"] = nil,
					["Mana"] = nil,
					["Buffs"] = { },
					["Debuffs"] = { },
					["Position"] = { }
				};
				update = 1;
			end
			CT_RA_Stats[player]["Mana"] = tonumber(val);
			CT_RA_UpdateUnit(player);
		end
	end

	if ( strsub(msg, 1, 3) == "PR " ) then
		local useless, useless, player = string.find(msg, "^PR (.+)$");
		if ( player and CT_RA_Stats[player] ) then
			CT_RA_Stats[player] = nil;
			CT_RA_UpdateUnit(player);
		end
	end

	if ( msg == "DB" ) then
		for i = 1, GetNumRaidMembers(), 1 do
			local user, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if ( rank >= 1 and user == nick ) then
				CT_RA_Print("<CTMod> Disbanding raid on request by '|c00FFFFFF" .. nick .. "|r'.", 1, 0.5, 0);
				LeaveParty();
			end
		end
	end

	return update;
end

-- Send messages
function CT_RA_AddMessage(msg)
	tinsert(CT_RA_Comm_MessageQueue, msg);
end

function CT_RA_SendMessage(msg, force)
	
	if ( GetNumRaidMembers() == 0 ) then return; end -- Mod should be disabled if not in raid
	msg = string.gsub(msg, "|Hitem:%d+:%d+:%d+:%d+|h(%[[^%|]+%])|h", "%1");
	msg = string.gsub(msg, "|c%w%w%w%w%w%w%w%w([^%|]+)|r", "%1");
	msg = string.gsub(msg, "s", "$");
	msg = string.gsub(msg, "S", "");
	if ( CT_RA_Channel and GetChannelName(CT_RA_Channel) and ( not CT_RA_LastSend or CT_RA_LastSend ~= msg or force ) ) then
		CT_RA_LastSend = msg;
		SendChatMessage(msg, "CHANNEL", nil, GetChannelName(CT_RA_Channel));
	end
end

function CT_RA_OnEvent(event)
	if ( event == "RAID_ROSTER_UPDATE" or event == "VARIABLES_LOADED" ) then
		if ( event == "RAID_ROSTER_UPDATE" ) then
			if ( GetNumRaidMembers() == 0 ) then
				CT_RA_MainTanks = { };
				CT_RA_MainTankStats = { };
				CT_RA_Stats = { };
				CT_RA_ButtonIndexes = { };
			end
			if ( GetNumRaidMembers() > CT_RA_NumRaidMembers ) then
				CT_RA_UpdateFrame.time = 3;
			end
		elseif ( event == "VARIABLES_LOADED" ) then
			CT_RA_UpdateFrame.time = 3;
		end
		CT_RA_NumRaidMembers = GetNumRaidMembers();
		CT_RAOptions_Update();
		CT_RA_UpdateRaidGroup();
		CT_RA_UpdateMTs();
		if ( not CT_RA_Channel and GetGuildInfo("player") ) then
			CT_RA_Channel = "CT" .. string.gsub(GetGuildInfo("player"), "[^%w]", "");
		end

	end
	if ( event == "UNIT_NAME_UPDATE" ) then
		if ( arg1 == "player" and UnitName("player") ~= "Unknown Unit" ) then
			if ( CT_RA_RaidParticipant ) then
				if ( CT_RA_RaidParticipant ~= UnitName("player") ) then
					CT_RA_Stats = { { } };
					CT_RA_MainTankStats = { };
					CT_RA_MainTanks = { };
					CT_RA_ButtonIndexes = { };
					CT_RA_UpdateRaidGroup();
				end
			end
			CT_RA_RaidParticipant = UnitName("player");
			-- Add chat frame stuff
			local info = CT_RA_ChatInfo["Default"];
			if ( CT_RA_ChatInfo[UnitName("player")] ) then
				info = CT_RA_ChatInfo[UnitName("player")];
			end
			ChatTypeInfo["CTRAID"].r = info.r;
			ChatTypeInfo["CTRAID"].g = info.g;
			ChatTypeInfo["CTRAID"].b = info.b;
		end
	end
	if ( event == "PARTY_MEMBERS_CHANGED" ) then
		CT_RAMenu_CheckParty();
	end

	if ( not CT_RA_Channel ) then return; end
	-- All events below this line requires CT_RA_Channel to be initialized

	if ( event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" ) then
		if ( arg1 == "player" ) then
			local health = floor(UnitHealth("player")/UnitHealthMax("player")*100);
			if ( not CT_RA_LastSent["health"] or abs(CT_RA_LastSent["health"]-health) >= CT_RA_Comm_HPChangeThreshold ) then
				CT_RA_AddMessage("H " .. health .. " " .. UnitHealthMax("player"));
				CT_RA_LastSent["health"] = health;
			end
			return;
		elseif ( strsub(arg1, 1, 5) == "party" ) then
			if ( CT_RA_PartyMembers[UnitName(arg1)] ) then
				local health = floor(UnitHealth(arg1)/UnitHealthMax(arg1)*100+0.5);
				if ( UnitIsDead(arg1) or UnitHealth(arg1) <= 1 ) then
					health = -1;
				end
				if ( not CT_RA_LastSent[arg1 .. "health"] or abs(CT_RA_LastSent[arg1 .. "health"]-health) >= CT_RA_Comm_HPChangeThreshold ) then
					CT_RA_AddMessage("PH " .. UnitName(arg1) .. " " .. health .. " " .. UnitHealthMax(arg1));
					CT_RA_LastSent[arg1 .. "health"] = health;
				end
			end
		elseif ( arg1 == "target" ) then
			for k, v in CT_RA_MainTanks do
				if ( UnitName("player") == v ) then
					-- Player is a main tank
					local health = floor(UnitHealth("target")/UnitHealthMax("target")*100);
					if ( UnitIsDead("target") ) then
						health = -1;
					end
					if ( not CT_RA_LastSent["mthealth"] or abs(CT_RA_LastSent["mthealth"]-health) >= CT_RA_Comm_MTHPChangeThreshold ) then
						CT_RA_AddMessage("MT " .. k .. " H " .. health);
						CT_RA_LastSent["mthealth"] = health;
					end
					return;
				end
			end
		end
	end

	if ( event == "PLAYER_TARGET_CHANGED" ) then
		for k, v in CT_RA_MainTanks do
			if ( v == UnitName("player") ) then
				if ( UnitExists("target") ) then
					local hasmana, friend, health, mana, name;
					if ( UnitManaMax("target") and UnitManaMax("target") > 0 and UnitPowerType("target") == 0 ) then
						hasmana = 1;
						mana = floor(UnitMana("target")/UnitManaMax("target")*100);
					else
						hasmana = 0;
						mana = -1;
					end
					health = floor(UnitHealth("target")/UnitHealthMax("target")*100);
					if ( UnitIsDead("target") ) then
						health = -1;
					end
					if ( UnitIsFriend("player", "target") ) then
						friend = 1;
					else
						friend = 0;
					end
					name = UnitName("target");
					CT_RA_AddMessage("TC " .. k .. " " .. hasmana .. " " .. friend .. " " .. health .. " " .. mana .. " " .. name);
					break;
				else
					CT_RA_AddMessage("LT " .. k);
				end
			end
		end
	end

	if ( event == "UNIT_MANA" or event == "UNIT_MAXMANA" or event == "UNIT_RAGE" or event == "UNIT_MAXRAGE" or event == "UNIT_ENERGY" or event == "UNIT_MAXENERGY" ) then
		if ( arg1 == "player" ) then
			local mana = floor(UnitMana("player")/UnitManaMax("player")*100);
			if ( not CT_RA_LastSent["mana"] or abs(CT_RA_LastSent["mana"]-mana) >= CT_RA_Comm_MPChangeThreshold ) then
				CT_RA_AddMessage("M " .. mana);
				CT_RA_LastSent["mana"] = mana;
			end
			return;
		elseif ( strsub(arg1, 1, 5) == "party" ) then
			if ( CT_RA_PartyMembers[UnitName(arg1)] ) then
				local mana = floor(UnitMana(arg1)/UnitManaMax(arg1)*100+0.5);
				if ( not CT_RA_LastSent[arg1 .. "mana"] or abs(CT_RA_LastSent[arg1 .. "mana"]-mana) >= CT_RA_Comm_MPChangeThreshold ) then
					CT_RA_AddMessage("PM " .. UnitName(arg1) .. " " .. mana);
					CT_RA_LastSent[arg1 .. "mana"] = mana;
				end
			end
		elseif ( arg1 == "target" ) then
			for k, v in CT_RA_MainTanks do
				if ( UnitName("player") == v ) then
					-- Player is a main tank
					if ( UnitPowerType("target") == 0 ) then
						local mana = floor(UnitMana("target")/UnitManaMax("target")*100);
						if ( not CT_RA_LastSent["mtmana"] or abs(CT_RA_LastSent["mtmana"]-mana) >= CT_RA_Comm_MTMPChangeThreshold ) then
							CT_RA_AddMessage("MT " .. k .. " M " .. mana);
							CT_RA_LastSent["mtmana"] = mana;
						end
					end
					return;
				end
			end
		end
	end

	if ( event == "PLAYER_AURAS_CHANGED" ) then
		local msgs = CT_RA_ScanAuras();
		if ( msgs ) then
			for k, v in msgs do
				CT_RA_AddMessage(v);
			end
			return;
		end
	end

	if ( event == "UI_ERROR_MESSAGE" ) then
		if ( CT_RA_LastCast and (GetTime()-CT_RA_LastCast) <= 0.1 ) then
			if ( CT_RA_LastCastType == "debuff" ) then
				CT_RA_AddToQueue(CT_RA_LastCastSpell["type"], CT_RA_LastCastSpell["nick"], CT_RA_LastCastSpell["name"]);
			else
				CT_RA_AddToQueue(CT_RA_LastCastSpell["name"], CT_RA_LastCastSpell["nick"]);
			end
			CT_RA_LastCast = nil;
			CT_RA_LastCastSpell = nil;
		end
	end

	if ( event == "PLAYER_DEAD" ) then
		CT_RA_AddMessage("H -1");
	end
end

function CT_RA_ScanAuras()
	local currauras = { 
		["buffs"] = { },
		["debuffs"] = { }
	};

	local changed = {
		["newbuffs"] = { },
		["expiredbuffs"] = { },
		["newdebuffs"] = { },
		["expireddebuffs"] = { }
	};

	local returnstr = { };

	for i = 0, 23, 1 do
		local buffIndex, untilCancelled = GetPlayerBuff(i, "HELPFUL");
		if ( buffIndex >= 0 ) then
			CT_RATooltip:SetPlayerBuff(buffIndex);
			local name = CT_RATooltipTextLeft1:GetText();
			if ( name ) then
				local useless, useless, texture = string.find(GetPlayerBuffTexture(buffIndex), "([%w_&]+)$");
				currauras["buffs"][name] = { ["texture"] = texture, ["timeleft"] = floor(GetPlayerBuffTimeLeft(buffIndex)+0.5), ["buffIndex"] = buffIndex };
			end
		end

		local buffIndex, untilCancelled = GetPlayerBuff(i, "HARMFUL");
		if ( buffIndex >= 0 ) then
			CT_RATooltip:SetPlayerBuff(buffIndex);
			local name = CT_RATooltipTextLeft1:GetText();
			local type = CT_RATooltipTextRight1:GetText();
			if ( not type or not CT_RATooltipTextRight1:IsVisible() ) then type = nil; end
			if ( CT_RATooltipTextLeft1:IsVisible() and name ) then
				local useless, useless, texture = string.find(GetPlayerBuffTexture(buffIndex), "([%w_&]+)$");
				currauras["debuffs"][name] = { ["name"] = name, ["type"] = type, ["time"] = GetPlayerBuffTimeLeft(buffIndex), ["texture"] = texture };
			end
		end
	end

	-- Compare the tables
	for key, val in currauras["buffs"] do
		if ( not CT_RA_Auras["buffs"][key] ) then
			-- New buff
			CT_RA_BuffTimeLeft[key] = { val["timeleft"], val["buffIndex"] };
			changed["newbuffs"][key] = val;
		else
			-- Remove
			CT_RA_Auras["buffs"][key] = nil;
		end

	end
	for key, val in currauras["debuffs"] do
		if ( not CT_RA_Auras["debuffs"][key] ) then
			-- New debuff
			changed["newdebuffs"][key] = val; -- Using val because this value is a table
		else
			-- Remove
			CT_RA_Auras["debuffs"][key] = nil;
		end
	end

	for key, val in CT_RA_Auras["buffs"] do
		changed["expiredbuffs"][key] = 1;
		CT_RA_BuffTimeLeft[key] = nil;
	end

	for key, val in CT_RA_Auras["debuffs"] do
		changed["expireddebuffs"][key] = 1;
	end

	for key, val in changed["newbuffs"] do
		tinsert(returnstr, "B " .. val["texture"] .. " " .. val["timeleft"] .. " " .. key);
	end
	for key, val in changed["newdebuffs"] do
		if ( not val["type"] ) then val["type"] = string.gsub(val["name"], " ", "_"); end
		tinsert(returnstr, "D " .. val["time"] .. " " .. val["texture"] .. " " .. val["type"] .. " " .. val["name"]);
	end
	for key, val in changed["expiredbuffs"] do
		tinsert(returnstr, "BE " .. key);
	end
	for key, val in changed["expireddebuffs"] do
		tinsert(returnstr, "DE " .. key);
	end
	CT_RA_Auras = currauras;
	return returnstr;
end

function CT_RA_UpdateUnit(arr, obj)
	local nick, stats, var, frame;
	if ( type(arr) == "string" ) then
		nick = arr;
		for i=1, GetNumRaidMembers(), 1 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if ( name == arr ) then
				var = { name, online, isDead, class, fileName };
				frame = getglobal("CT_RAMember" .. i);
				break;
			end
		end
	elseif ( type(arr) == "table" ) then
		frame = obj;
		var = arr;
		nick = arr[1];
	else
		return;
	end
	if ( not frame ) then
		return;
	end
	stats = CT_RA_Stats[nick];
	if ( frame.group and CT_RA_ShowGroups[frame.group:GetID()] ) then
		frame:Show();
	end
	getglobal(frame:GetName() .. "Name"):SetText(nick);
	if ( not var[2] ) then
		if ( CT_RA_HideOffline ) then
			frame:Hide();
		end
		for i = 1, 4, 1 do
			if ( i <= 2 ) then
				getglobal(frame:GetName() .. "DebuffButton" .. i):Hide();
			end
			getglobal(frame:GetName() .. "BuffButton" .. i):Hide();
		end
		frame:SetBackdropColor(0.3, 0.3, 0.3, 1);
		getglobal(frame:GetName() .. "Status"):SetText("OFFLINE");
		getglobal(frame:GetName() .. "Status"):Show();
		getglobal(frame:GetName() .. "HPBar"):Hide();
		getglobal(frame:GetName() .. "Percent"):Hide();
		getglobal(frame:GetName() .. "MPBar"):Hide();
		getglobal(frame:GetName() .. "Name"):SetTextColor(0.75, 0.75, 0.75);
		return;
	elseif ( not stats ) then
		if ( CT_RA_HideNA and var[2] ) then
			frame:Hide();
		end
		frame:SetBackdropColor(0.3, 0.3, 0.3, 1);
		getglobal(frame:GetName() .. "Name"):SetTextColor(0.5, 0.5, 0.5);
		getglobal(frame:GetName() .. "Status"):SetText("N/A");
		getglobal(frame:GetName() .. "Status"):Show()

		getglobal(frame:GetName() .. "HPBar"):Hide();
		getglobal(frame:GetName() .. "Percent"):Hide();
		getglobal(frame:GetName() .. "MPBar"):Hide();
		return;
	end
	getglobal(frame:GetName() .. "Status"):Hide();
	if ( var[4] == "Warrior" ) then
		getglobal(frame:GetName() .. "MPBar"):SetStatusBarColor(1, 0, 0);
	elseif ( var[4] == "Rogue" ) then
		getglobal(frame:GetName() .. "MPBar"):SetStatusBarColor(1, 1, 0);
	else
		getglobal(frame:GetName() .. "MPBar"):SetStatusBarColor(0, 0, 1);
	end

	-- Feign Death check
	for k, v in stats["Buffs"] do
		if ( k == "Feign Death" ) then
			-- Feign death
			getglobal(frame:GetName() .. "Status"):Show();
			frame:SetBackdropColor(0.5, 0.5, 0.5, 1);
			getglobal(frame:GetName() .. "Status"):SetText("Feign Death");
			getglobal(frame:GetName() .. "HPBar"):Hide();
			getglobal(frame:GetName() .. "Percent"):Hide();
			getglobal(frame:GetName() .. "MPBar"):Hide();
			getglobal(frame:GetName() .. "Name"):SetTextColor(0.75, 0.75, 0.75);
			return;
		end
	end

	-- Health

	if ( stats["Health"] and stats["Health"] > 0 and not var[3] ) then
		if ( stats["Health"] > 100 ) then
			stats["Health"] = 100;
		end
		getglobal(frame:GetName() .. "HPBar"):SetValue(stats["Health"]);
		if ( CT_RA_ShowHP and CT_RA_ShowHP == 1 and stats["Healthmax"] ) then
			getglobal(frame:GetName() .. "Percent"):SetText(floor(stats["Health"]/100*stats["Healthmax"]) .. "/" .. stats["Healthmax"]);
		else
			getglobal(frame:GetName() .. "Percent"):SetText(stats["Health"] .. "%");
		end
		local color = RAID_CLASS_COLORS[var[5]];
		getglobal(frame:GetName() .. "Name"):SetTextColor(color.r, color.g, color.b);
		local percent = stats["Health"]/100;
		local r, g;
		if ( percent > 0.5 and percent <= 1) then
			g = 1;
			r = (1.0 - percent) * 2;
		elseif ( percent >= 0 and percent <= 0.5 ) then
			r = 1.0;
			g = percent * 2;
		else
			r = 0;
			g = 1;
		end
		getglobal(frame:GetName() .. "HPBar"):SetStatusBarColor(r, g, 0);
		if ( CT_RA_MemberHeight == 40 or CT_RA_MemberHeight == 36 ) then
			getglobal(frame:GetName() .. "HPBar"):Show();
			if ( CT_RA_ShowHP ) then
				getglobal(frame:GetName() .. "Percent"):Show();
			end
		end
	elseif ( ( stats["Health"] and stats["Health"] <= 0 ) or var[3] ) then
		getglobal(frame:GetName() .. "Status"):Show();
		frame:SetBackdropColor(0.3, 0.3, 0.3, 1);
		getglobal(frame:GetName() .. "Status"):SetText("DEAD");
		getglobal(frame:GetName() .. "HPBar"):Hide();
		getglobal(frame:GetName() .. "Percent"):Hide();
		getglobal(frame:GetName() .. "MPBar"):Hide();
		getglobal(frame:GetName() .. "Name"):SetTextColor(0.5, 0.5, 0.5);
		return;
	end

	-- Mana
	if ( stats["Mana"] ) then
		getglobal(frame:GetName() .. "MPBar"):SetValue(stats["Mana"]);
		if ( CT_RA_MemberHeight == 40 or CT_RA_MemberHeight == 32 ) then
			getglobal(frame:GetName() .. "MPBar"):Show();
		end
	end

	-- Buffs
	local num = 1;
	if ( not CT_RA_ShowDebuffs ) then
		for key, val in CT_RA_BuffArray do
			if ( num <= 4 and stats["Buffs"][val["name"]] and val["show"] ~= -1 ) then -- Change 4 to number of buffs
				getglobal(frame:GetName() .. "BuffButton" .. num .. "Icon"):SetTexture("Interface\\Icons\\" .. stats["Buffs"][val["name"]][1]);
				getglobal(frame:GetName() .. "BuffButton" .. num).name = val["name"];
				getglobal(frame:GetName() .. "BuffButton" .. num).owner = nick;
				getglobal(frame:GetName() .. "BuffButton" .. num):Show();
				num = num + 1;
			end
		end
	end
	for i = num, 4, 1 do -- Change 4 to number of buffs
		getglobal(frame:GetName() .. "BuffButton" .. i):Hide();
	end

	-- Debuffs
	num = 1;
	if ( var[2] and not var[3] ) then
		local setbg = 0;

		frame:SetBackdropColor(CT_RA_DefaultColor.r, CT_RA_DefaultColor.g, CT_RA_DefaultColor.b, CT_RA_DefaultColor.a);
		for key, val in CT_RA_DebuffColors do
			for k, v in stats["Debuffs"] do
				if ( val["type"] == v[1] and val["id"] ~= -1 and ( v[2] >= 10 or not CT_RA_HideShort ) ) then
					if ( CT_RA_ShowDebuffs and num <= 2 ) then
						getglobal(frame:GetName() .. "DebuffButton" .. num .. "Icon"):SetTexture("Interface\\Icons\\" ..v[3]);
						getglobal(frame:GetName() .. "DebuffButton" .. num).name = k;
						getglobal(frame:GetName() .. "DebuffButton" .. num):Show();
						num = num + 1;
					end
					if ( setbg == 0 ) then
						frame:SetBackdropColor(val.r, val.g, val.b, val.a);
						setbg = 1;
					end
				end
			end
		end
	end
	for i = num, 2, 1 do
		getglobal(frame:GetName() .. "DebuffButton" .. i):Hide();
	end
end

function CT_RA_SortClassArray(arr)

	local classValues = {
		["Warrior"] = 8,
		["Paladin"] = 7,
		["Druid"] = 6,
		["Mage"] = 5,
		["Warlock"] = 4,
		["Rogue"] = 3,
		["Hunter"] = 2,
		["Priest"] = 1,
		["Shaman"] = 0
	};

	-- A little more advanced BubbleSort algorithm

	local limit, st, j, temp, swapped;
	limit = getn(arr);
	st = 0;
	while ( st < limit ) do
		swapped = false;
		st = st + 1;
		limit = limit - 1;
		local val, val1;

		for j = st, limit, 1 do
			if ( arr[j]["class"] ) then
				val = classValues[arr[j]["class"]];
			else
				val = 0;
			end
			if ( arr[j+1]["class"] ) then
				val1 = classValues[arr[j+1]["class"]];
			else
				val1 = 0;
			end
			if ( val < val1 ) then
				temp = arr[j];
				arr[j] = arr[j+1];
				arr[j+1] = temp;
				swapped = true;
			end
		end
		if ( not swapped ) then return arr; end

		swapped = false;
		for j=limit, st, -1 do
			if ( arr[j]["class"] ) then
				val = classValues[arr[j]["class"]];
			else
				val = 0;
			end
			if ( arr[j+1]["class"] ) then
				val1 = classValues[arr[j+1]["class"]];
			else
				val1 = 0;
			end

			if ( val < val1 ) then
				temp = arr[j];
				arr[j] = arr[j+1];
				arr[j+1] = temp;
				swapped = true;
			end
		end
		if ( not swapped ) then return arr; end
	end
	return arr;
end

function CT_RA_UpdateMTs()
	CT_RAMTGroupGroupName:SetText("MT Targets");
	CT_RAMTGroup:Hide();
	CT_RAMTGroupDrag:Hide();
	CT_RAMTGroupGroupName:Hide();
	for i = 1, 5, 1 do
		getglobal("CT_RAMTGroupMember" .. i):Hide();
	end
	if ( GetNumRaidMembers() == 0 ) then return; end
	for key, val in CT_RA_MainTanks do
		if ( CT_RA_ShowMTs[key] ) then
			local frame = getglobal("CT_RAMTGroupMember" .. key);
			frame:SetBackdropColor(CT_RA_DefaultColor["r"], CT_RA_DefaultColor["g"], CT_RA_DefaultColor["g"], CT_RA_DefaultColor["a"]);
			frame:GetParent():Show();
			frame:Show();
			if ( CT_RA_HideBorder ) then
				getglobal(frame:GetName().. "Percent"):SetPoint("TOP", frame:GetName(), "TOP", 2, -16);
				frame:SetBackdropBorderColor(1, 1, 1, 0);
				getglobal(frame:GetName() .. "HPBar"):SetPoint("TOPLEFT", frame:GetName(), "TOPLEFT", 10, -19);
				frame:SetHeight(CT_RA_MemberHeight-3);
			else
				frame:SetBackdropBorderColor(1, 1, 1, 1);
				getglobal(frame:GetName() .. "HPBar"):SetPoint("TOPLEFT", frame:GetName(), "TOPLEFT", 10, -22);
				getglobal(frame:GetName().. "Percent"):SetPoint("TOP", frame:GetName(), "TOP", 2, -18);
				frame:SetHeight(CT_RA_MemberHeight);
			end
			if ( not CT_RA_HideNames ) then
				getglobal(frame:GetParent():GetName() .. "GroupName"):Show();
			else
				getglobal(frame:GetParent():GetName() .. "GroupName"):Hide();
			end
			if ( not CT_RA_LockGroups ) then
				CT_RAMTGroupDrag:Show();
			end
			if ( CT_RA_MainTankStats[key] ) then
				local v = CT_RA_MainTankStats[key];	
				getglobal(frame:GetName() .. "Name"):SetHeight(15);
				getglobal(frame:GetName() .. "Status"):Hide();
				getglobal(frame:GetName() .. "HPBar"):Show();
				getglobal(frame:GetName() .. "MPBar"):Show();
				getglobal(frame:GetName() .. "Name"):Show();
				if ( v["health"] ~= -1 and v["health"] and type(v["health"]) == "number" ) then
					if ( CT_RA_ShowHP ) then
						getglobal(frame:GetName() .. "Percent"):Show();
					else
						getglobal(frame:GetName() .. "Percent"):Hide();
					end
					getglobal(frame:GetName() .. "HPBar"):SetValue(v["health"]);
					getglobal(frame:GetName() .. "Percent"):SetText(v["health"] .. "%");
					local percent = v["health"]/100;
					if ( percent >= 0 and percent <= 1 ) then
						local r, g;
						if ( percent > 0.5 ) then
							g = 1;
							r = (1.0 - percent) * 2;
						else
							r = 1;
							g = percent * 2;
						end
						getglobal(frame:GetName() .. "HPBar"):SetStatusBarColor(r, g, 0);
					end
				elseif ( v["health"] == -1 ) then
					getglobal(frame:GetName() .. "HPBar"):Hide();
					getglobal(frame:GetName() .. "MPBar"):Hide();
					getglobal(frame:GetName() .. "Status"):Show();
					getglobal(frame:GetName() .. "Status"):SetText("DEAD");
				else
					getglobal(frame:GetName() .. "HPBar"):Hide();
				end
				if ( v["hasmana"] == 1 and ( CT_RA_MemberHeight == 40 or CT_RA_MemberHeight == 32 ) ) then
					if ( CT_RA_HideBorder ) then
						frame:SetHeight(37);
					else
						frame:SetHeight(40);
					end
					getglobal(frame:GetName() .. "MPBar"):Show();
					getglobal(frame:GetName() .. "MPBar"):SetValue(v["mana"]);
				else
					getglobal(frame:GetName() .. "MPBar"):Hide();
					if ( CT_RA_HideBorder ) then
						frame:SetHeight(33);
					else
						frame:SetHeight(36);
					end
				end
				getglobal(frame:GetName() .. "Name"):SetText(v["name"]);
				getglobal(frame:GetName() .. "CastFrameBottom").name = v["name"];
				getglobal(frame:GetName() .. "CastFrameTop").name = v["name"];
			else
				getglobal(frame:GetName() .. "Percent"):Hide();
				getglobal(frame:GetName() .. "HPBar"):Hide();
				getglobal(frame:GetName() .. "MPBar"):Hide();
				getglobal(frame:GetName() .. "Status"):Hide();
				getglobal(frame:GetName() .. "Name"):SetText("" .. val .. "'s Target");
				getglobal(frame:GetName() .. "Name"):SetHeight(30);
			end
		end
	end
end

function CT_RA_UpdateRaidGroup()
	for i = 1, 8, 1 do
		getglobal("CT_RAGroup" .. i):Hide();
		getglobal("CT_RAGroup" .. i).next = nil;
		getglobal("CT_RAGroup" .. i .. "GroupName"):Hide();
		getglobal("CT_RAGroupDrag" .. i):Hide();
	end
	if ( CT_RA_SORTTYPE == "group" ) then
		CT_RA_SortByGroup();
	elseif ( CT_RA_SORTTYPE == "custom" ) then
		CT_RA_SortByCustom();
	elseif ( CT_RA_SORTTYPE == "class" ) then
		CT_RA_SortByClass();
	end
	local numRaidMembers = GetNumRaidMembers();
	local name, rank, subgroup, level, class, fileName, zone, online, isDead;
	for i=1, MAX_RAID_MEMBERS do
		if ( i <= numRaidMembers ) then
			name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if ( CT_RA_Stats[name] and CT_RA_Stats[name]["Health"] and CT_RA_Stats[name]["Health"] <= 1 ) then
				isDead = 1;
			end
			-- Set Rank
			if ( name == UnitName("player") ) then
				CT_RA_Level = rank;
			end
			local button = getglobal("CT_RAMember" .. i);
			local group = button.group;
			if ( group ) then
				group:Hide();
				button:Hide();
				getglobal("CT_RAGroupDrag" .. group:GetID()):Hide();

				if ( CT_RA_ShowGroups and CT_RA_ShowGroups[group:GetID()] ) then
					if ( CT_RA_HideBorder ) then
						if ( CT_RA_MemberHeight == 28 ) then
							getglobal(button:GetName() .. "BuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -5);
							getglobal(button:GetName() .. "DebuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -5);
						else
							getglobal(button:GetName() .. "BuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -3);
							getglobal(button:GetName() .. "DebuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -3);
						end
						getglobal(button:GetName().. "Percent"):SetPoint("TOP", button:GetName(), "TOP", 2, -16);
						getglobal("CT_RAMember" .. i):SetBackdropBorderColor(1, 1, 1, 0);
						getglobal(button:GetName() .. "HPBar"):SetPoint("TOPLEFT", button:GetName(), "TOPLEFT", 10, -19);
						button:SetHeight(CT_RA_MemberHeight-3);
					else
						getglobal(button:GetName() .. "BuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -5);
						getglobal(button:GetName() .. "DebuffButton1"):SetPoint("TOPRIGHT", button:GetName(), "TOPRIGHT", -5, -5);
						getglobal("CT_RAMember" .. i):SetBackdropBorderColor(1, 1, 1, 1);
						getglobal(button:GetName() .. "HPBar"):SetPoint("TOPLEFT", button:GetName(), "TOPLEFT", 10, -22);
						getglobal(button:GetName().. "Percent"):SetPoint("TOP", button:GetName(), "TOP", 2, -18);
						button:SetHeight(CT_RA_MemberHeight);
					end
					if ( CT_RA_MemberHeight == 40 or CT_RA_MemberHeight == 32 ) then
						getglobal(button:GetName() .. "MPBar"):Show();
					else
						getglobal(button:GetName() .. "MPBar"):Hide();
					end
					-- Show button and group
					group:Show();
					if ( group.num and group.num >= 1 ) then
						if ( not CT_RA_HideNames ) then
							getglobal(group:GetName() .. "GroupName"):Show();
						else
							getglobal(group:GetName() .. "GroupName"):Hide();
						end
						if ( not CT_RA_LockGroups ) then
							getglobal("CT_RAGroupDrag" .. group:GetID()):Show();
						else
							getglobal("CT_RAGroupDrag" .. group:GetID()):Hide();
						end
					end
					getglobal(button:GetName() .. "Status"):Hide();
					if ( CT_RA_MemberHeight == 32 or CT_RA_MemberHeight == 28 ) then
						getglobal(button:GetName() .. "HPBar"):Hide();
						getglobal(button:GetName() .. "Percent"):Hide();
					else
						if ( CT_RA_ShowHP ) then
							getglobal(button:GetName() .. "Percent"):Show();
						else
							getglobal(button:GetName() .. "Percent"):Hide();
						end
						getglobal(button:GetName() .. "HPBar"):Show();
					end
					CT_RA_ClearMember(button);
					getglobal(button:GetName() .. "Name"):SetText(name);
					getglobal(button:GetName() .. "CastFrameBottom").name = name;
					getglobal(button:GetName() .. "CastFrameTop").name = name;
					CT_RA_UpdateUnit({ name, online, isDead, class, fileName}, button);
				end
			end
		else
			getglobal("CT_RAMember" .. i):Hide();
			getglobal("CT_RAMember" .. i).next = nil;
		end
	end
end		
		
function CT_RA_Drag_OnEnter()
	if ( this:GetCenter() < UIParent:GetCenter() ) then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	else
		GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	end
	GameTooltip:SetText("Click to drag");
end

function CT_RA_ClearMember(frame)
	getglobal(frame:GetName() .. "HPBar"):SetMinMaxValues(0, 100);
	getglobal(frame:GetName() .. "MPBar"):SetMinMaxValues(0, 100);

	getglobal(frame:GetName() .. "HPBar"):SetValue(100);
	getglobal(frame:GetName() .. "MPBar"):SetValue(100);


	getglobal(frame:GetName() .. "Name"):SetText("");
	frame:SetBackdropColor(CT_RA_DefaultColor.r, CT_RA_DefaultColor.g, CT_RA_DefaultColor.b, CT_RA_DefaultColor.a);
	getglobal(frame:GetName() .. "Name"):SetTextColor(1, 0.82, 0);
	for i = 1, 4, 1 do -- Change 4 to number of buffs
		getglobal(frame:GetName() .. "BuffButton" .. i .. "Icon"):SetTexture(nil);
		getglobal(frame:GetName() .. "BuffButton" .. i):Hide();
	end
end

function CT_RA_BuffButton_OnEnter()
	if ( CT_RA_LockPosition ) then return; end
	if ( this:GetCenter() < UIParent:GetCenter() ) then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	else
		GameTooltip:SetOwner(this, "ANCHOR_LEFT");
	end
	local left;
	if ( CT_RA_Stats[this.owner] and CT_RA_Stats[this.owner]["Buffs"][this.name] and CT_RA_Stats[this.owner]["Buffs"][this.name][2] ) then
		left = CT_RA_Stats[this.owner]["Buffs"][this.name][2];
	end
	if ( this.name and left) then
		local str;
		if ( left > 60 ) then
			mins = floor(left/60);
			secs = left-mins*60;
		else
			mins = 0;
			secs = left;
		end
		if ( mins < 10 ) then mins = "0" .. mins; end
		if ( secs < 10 ) then secs = "0" .. secs; end
		GameTooltip:SetText(this.name .. " (" .. mins .. ":" .. secs .. ")");
	elseif ( this.name ) then
		GameTooltip:SetText(this.name);
	end
end

function CT_RA_AssistMT(id)
	if ( CT_RA_MainTanks[id] ) then
		AssistByName(CT_RA_MainTanks[id]);
	end
end

function CT_RA_MemberFrame_OnClick(button)
	local name, mt;
	if ( strsub(this:GetParent():GetName(), 1, 12) == "CT_RAMTGroup" ) then
		mt = 1;
		local id = this:GetParent():GetParent():GetID();
		if ( CT_RA_MainTanks[id] ) then
			name = CT_RA_MainTanks[id];
		end
	else
		if ( not this.name ) then return; end
		name = this.name;
	end
	for i = 1, GetNumRaidMembers(), 1 do
		local membername = GetRaidRosterInfo(i);
		if ( membername == name ) then
			if ( mt ) then
				AssistUnit("raid" .. i);
			else
				if ( SpellIsTargeting() ) then
					SpellTargetUnit("raid" .. i);
				else
					TargetUnit("raid" .. i);
				end
			end
			return;
		end
	end
end

function CT_RA_SendStatus()
	CT_RA_Auras = { 
		["buffs"] = { },
		["debuffs"] = { }
	}; -- Reset everything so every buff & debuff is treated as new
	local arr = CT_RA_ScanAuras();
	for key, val in arr do
		CT_RA_AddMessage(val);
	end
	local health = ceil(UnitHealth("player")/UnitHealthMax("player")*100);
	if ( UnitIsDeadOrGhost("player") ) then
		health = -1;
	end
	CT_RA_AddMessage("P " .. health .. " " .. UnitHealthMax("player") .. " " .. ceil(UnitMana("player")/UnitManaMax("player")*100));
end	

SLASH_RA1 = "/raidassist";
SLASH_RS1 = "/rs";

SlashCmdList["RS"] = function(msg)
	if ( CT_RA_Level >= 1 ) then
		CT_RA_AddMessage("MS " .. msg);
	else
		CT_RA_Print("<CTMod> You must be promoted or leader to do that!", 1, 1, 0);
	end
end

SlashCmdList["RA"] = function(msg)
	if ( msg == "" or msg == "help" ) then
		CT_RA_Print("<CTMod> RaidAssist uses the following slash commmands:", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/raidassist update|r - Updates raid stats (requires leader or promoted status)", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/raidassist set channel|r - Sets RaidAssist to monitor channel 'channel'", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/raidassist join|r - Joins the RaidAssist channel", 1, 0.5, 0);
		CT_RA_Print("<CTMod> There are also other commands", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/rakeyword keyword|r - Automatically invites people whispering you the set keyword", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/rainvite minlevel-maxlevel|r or |c00FFFFFF/rainvite level|r - Invites people within the set level range", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/radisband|r - Disbands the raid (requires leader or promoted status)", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/rashow|r - Shows raid windows that were hidden with /rahide", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/rashow all|r - Shows all raid windows", 1, 0.5, 0);
		CT_RA_Print("<CTMod> |c00FFFFFF/rahide|r - Hides all raid windows", 1, 0.5, 0);
	elseif ( msg == "update" and CT_RA_Level >= 1 ) then
		CT_RA_AddMessage("SR");
		CT_RA_Print("<CTMod> Stats have been updated for the raid group.", 1, 0.5, 0);
	elseif ( msg == "update" and CT_RA_Level < 1 ) then
		CT_RA_Print("<CTMod> You must be promoted or leader to do that!", 1, 0.5, 0);
	elseif ( msg == "join" ) then
		CT_RAMenu_General_JoinChannel();	
	else
		local useless, useless, chan = string.find(msg, "^set (.+)$");
		if ( chan ) then
			CT_RA_Channel = chan;
			CT_RA_Print("<CTMod> Set RaidAssist channel to '|c00FFFFFF" .. chan .. "|r'. You can write |c00FFFFFF/raidassist join|r to join this channel.", 1, 0.5, 0);
		end
	end
end

function CT_RA_CureLastDebuff()
	local debuff = CT_RA_GetDebuff();
	if ( not debuff ) then return; end

	-- Check to make sure the player is debuffed with selected
	if ( CT_RA_Stats[debuff["nick"]] ) then
		local found;
		for k, v in CT_RA_Stats[debuff["nick"]]["Debuffs"] do
			if ( v[1] == debuff["type"] ) then
				found = 1;
			end
		end
		if ( not found ) then 
			return;
		end
	else
		return;
	end

	local cure = CT_RA_GetCure(debuff["type"]);
	if ( cure ) then

		CT_RA_LastCastSpell = debuff;
		CT_RA_LastCast = GetTime();
		CT_RA_LastCastType = "debuff";

		local i, targetunit, targetname;
		-- Check parties
		if ( UnitExists("target") ) then
			for i = 1, 4, 1 do
				if ( UnitIsUnit("party" ..i, "target") ) then
					targetunit = "party" .. i;
					break;
				end
			end
			if ( UnitIsUnit("target", "pet" ) ) then
				targetunit = "pet";
			elseif ( UnitIsUnit("target", "player" ) ) then
				targetunit = "player";
			elseif ( UnitIsFriend("player", "target") ) then
				targetunit = "friend";
				targetname = UnitName("target");
			else
				targetunit = "lastenemy";
			end
		end

		TargetByName(debuff["nick"]);
		if ( not UnitExists("target") or UnitName("target") ~= debuff["nick"] ) then
			if ( targetunit ) then
				if ( targetunit == "lastenemy" ) then
					TargetLastEnemy();
				elseif ( targetunit == "friend" ) then
					TargetByName(targetname);
				else
					TargetUnit(targetunit);
				end
			else
				ClearTarget();
			end
			return;
		end
		CastSpell(CT_RA_ClassSpells[cure]["spell"], CT_RA_ClassSpells[cure]["tab"]+1);
		if ( SpellIsTargeting() and not SpellCanTargetUnit("target") ) then
			SpellStopTargeting();
		end
	end
end


function CT_RA_AddToQueue(type, nick, name)
	tinsert(CT_RA_BuffsToCure, { ["type"] = type, ["nick"] = nick, ["name"] = name });
end

function CT_RA_GetDebuff()
	local remove = "";
	for key, val in CT_RA_BuffsToCure do
		remove = key;
	end
	local arr = CT_RA_BuffsToCure[remove];
	CT_RA_BuffsToCure[remove] = nil;
	return arr;
end

function CT_RA_GetCure(school)
	local arr = {
		["Priest"] = { ["Magic"] = "Dispel Magic", ["Disease"] = { "Cure Disease", "Abolish Disease" } },
		["Shaman"] = { ["Disease"] = "Cure Disease", ["Poison"] = "Cure Poison" },
		["Druid"] = { ["Curse"] = "Remove Curse", ["Poison"] = { "Cure Poison", "Abolish Poison" } },
		["Mage"] = { ["Curse"] = "Remove Lesser Curse" },
		["Paladin"] = { ["Magic"] = { "Purify", "Cleanse" }, ["Poison"] = { "Purify", "Cleanse" }, ["Disease"] = { "Purify", "Cleanse" } }
	};

	if ( arr[UnitClass("player")] and arr[UnitClass("player")][school] ) then
		local tmp = arr[UnitClass("player")][school];
		if ( type(tmp) == "table" ) then
			for i = getn(tmp), 1, -1 do
				if ( CT_RA_ClassSpells[tmp[i]] ) then
					return tmp[i];
				end
			end
			return nil;
		else
			if ( CT_RA_ClassSpells[tmp] ) then
				return tmp;
			else
				return nil;
			end
		end
	end
	return nil;
end

function CT_RA_UpdateRaidGroupColors()
	for y = 1, 40, 1 do
		if ( y <= 5 ) then
			getglobal("CT_RAMTGroupMember" .. y):SetBackdropColor(CT_RA_DefaultColor.r, CT_RA_DefaultColor.g, CT_RA_DefaultColor.b, CT_RA_DefaultColor.a);
			getglobal("CT_RAMTGroupMember" .. y .. "Percent"):SetTextColor(CT_RA_PercentColor.r, CT_RA_PercentColor.g, CT_RA_PercentColor.b);
		end
		getglobal("CT_RAMember" .. y):SetBackdropColor(CT_RA_DefaultColor.r, CT_RA_DefaultColor.g, CT_RA_DefaultColor.b, CT_RA_DefaultColor.a);
		getglobal("CT_RAMember" .. y .. "Percent"):SetTextColor(CT_RA_PercentColor.r, CT_RA_PercentColor.g, CT_RA_PercentColor.b);
	end
end

function CT_RA_UpdateRaidMovability()
	for i = 1, 8, 1 do
		if ( CT_RA_LockGroups or not CT_RA_ShowGroups or not CT_RA_ShowGroups[i] ) then
			getglobal("CT_RAGroupDrag" .. i):Hide();
		else
			if ( getglobal("CT_RAGroup" .. i).next ) then
				getglobal("CT_RAGroupDrag" .. i):Show();
			end
		end
	end
	if ( CT_RA_LockGroups or not CT_RA_ShowMTs or not CT_RA_ShowMTs[i] ) then
		getglobal("CT_RAMTGroupDrag"):Hide();
	else
		for i = 1, 5, 1 do
			if ( CT_RA_MainTanks[i] ) then
				CT_RAMTGroupDrag:Show();
				break;
			else
				CT_RAMTGroupDrag:Hide();
			end
		end
	end
end

function CT_RA_AddToBuffQueue(name, nick)
	tinsert(CT_RA_BuffsToRecast, { ["name"] = name, ["nick"] = nick });
end

function CT_RA_GetBuff()
	if ( not CT_RA_BuffsToRecast or getn(CT_RA_BuffsToRecast) == 0 ) then return nil; end
	local arr = CT_RA_BuffsToRecast[getn(CT_RA_BuffsToRecast)];
	CT_RA_BuffsToRecast[getn(CT_RA_BuffsToCure)] = nil;
	return arr;
end

function CT_RA_RecastLastBuff()
	local buff = CT_RA_GetBuff();
	if ( buff ) then
		if ( CT_RA_Stats[buff["nick"]] and CT_RA_Stats[buff["nick"]]["Buffs"][buff["name"]] ) then
			return;
		end

		CT_RA_LastCastSpell = buff;
		CT_RA_LastCast = GetTime();
		CT_RA_LastCastType = "buff";
		TargetByName(buff["nick"]);
		if ( not UnitExists("target") or UnitName("target") ~= buff["nick"] ) then
			return;
		end
		CastSpell(CT_RA_ClassSpells[buff["name"]]["spell"], CT_RA_ClassSpells[buff["name"]]["tab"]+1);
		if ( SpellIsTargeting() and not SpellCanTargetUnit("target") ) then
			SpellStopTargeting();
		end
	end
end

function CT_RA_Print(msg, r, g, b)
	if ( SIMPLE_CHAT == "1" ) then
		DEFAULT_CHAT_FRAME:AddMessage(msg, r, g, b);
	else
		event = "CHAT_MSG_CTRAID";
		arg1 = msg;
		arg2 = "";
		arg3 = "";
		arg4 = "";
		arg6 = "";
		local info = CT_RA_ChatInfo["Default"];
		if ( CT_RA_ChatInfo[UnitName("player")] ) then
			info = CT_RA_ChatInfo[UnitName("player")];
		end
		for i = 1, 7, 1 do
			for k, v in info["show"] do
				if ( v == "ChatFrame" .. i ) then
					this = getglobal("ChatFrame" .. i);
					CT_RA_oldChatFrame_OnEvent(event);
				end
			end
		end
	end
end

function CT_RA_SortByClass()
	CT_RA_SORTTYPE = "class";
	CT_RA_ButtonIndexes = { };
	CT_RA_CurrPositions = { };
	local groupnum = 1;
	local membernum = 1;
	
	for k, v in CT_RA_ClassPositions do
		getglobal("CT_RAOptionsGroup" .. v .. "Label"):SetText(k);
		getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. v .. "Text"):SetText(k);
		getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. v .. "Text"):SetText(k);
	end
	for i = 1, 40, 1 do
		if ( i <= 8 ) then
			getglobal("CT_RAGroup" .. i).next = nil;
			getglobal("CT_RAGroup" .. i).num = 0;
		end
		getglobal("CT_RAMember" .. i).next = nil;
	end
	for i = 1, GetNumRaidMembers(), 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		if ( class and CT_RA_ClassPositions[class] ) then
			local group = getglobal("CT_RAGroup" .. CT_RA_ClassPositions[class]);
			CT_RA_CurrPositions[i] = CT_RA_ClassPositions[class];
			local button = getglobal("CT_RAMember" .. i);
			getglobal(group:GetName() .. "GroupName"):SetText(class);
			local modifier = 0.5;
			if ( not online ) then
				modifier = 0.3;
			end
			getglobal("CT_RAOptionsGroupButton" .. i .."Texture"):SetVertexColor(modifier, modifier, modifier);
			getglobal("CT_RAOptionsGroupButton" .. i .."Rank"):SetTextColor(modifier, modifier, modifier);
			getglobal("CT_RAOptionsGroupButton" .. i .."Name"):SetTextColor(modifier, modifier, modifier);
			getglobal("CT_RAOptionsGroupButton" .. i .."Level"):SetTextColor(modifier, modifier, modifier);
			getglobal("CT_RAOptionsGroupButton" .. i .."Class"):SetTextColor(modifier, modifier, modifier);
			if ( ( not CT_RA_HideOffline or online ) and ( CT_RA_Stats[name] or not CT_RA_HideNA ) ) then
				button:ClearAllPoints();
				local new;
				if ( group.next and group.next ~= button ) then
					new = group;
					while ( new.next ) do
						if ( new.next ) then
							new = new.next;
						end
					end
					group.num = group.num + 1;
					button:SetPoint("TOPLEFT", new:GetName(), "BOTTOMLEFT", 0, 4);
				else
					group.num = 1;
					new = group;
					button:SetPoint("TOPLEFT", group:GetName(), "TOPLEFT", 0, -20);
				end
				new.next = button;
				button.group = group;
			end
		end
	end
end

function CT_RA_SortByGroup()
	CT_RA_SORTTYPE = "group";
	CT_RA_ButtonIndexes = { };
	CT_RA_CurrPositions = { };
	local groupnum = 1;
	local membernum = 1;
	for i = 1, 40, 1 do
		if ( i <= 8 ) then
			getglobal("CT_RAGroup" .. i).next = nil;
			getglobal("CT_RAGroup" .. i).num = 0;
			getglobal("CT_RAOptionsGroup" .. i .. "Label"):SetText("Group " .. i);
			getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "Text"):SetText("Group " .. i);
			getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "Text"):SetText("Group " .. i);
		end
		getglobal("CT_RAMember" .. i).next = nil;
	end
	for i = 1, GetNumRaidMembers(), 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		if ( ( not CT_RA_HideOffline or online ) and ( CT_RA_Stats[name] or not CT_RA_HideNA ) ) then
			CT_RA_CurrPositions[i] = subgroup;
			local group = getglobal("CT_RAGroup" .. subgroup);
			getglobal(group:GetName() .. "GroupName"):SetText("Group " .. subgroup);
			getglobal("CT_RAOptionsGroupButton" .. i .."Texture"):SetVertexColor(1.0, 1.0, 1.0);

			local button = getglobal("CT_RAMember" .. i);
			button:ClearAllPoints();
			local new;
			if ( group.next and group.next ~= button ) then
				new = group;
				while ( new.next ) do
					if ( new.next ) then
						new = new.next;
					end
				end
				group.num = group.num + 1;
				button:SetPoint("TOPLEFT", new:GetName(), "BOTTOMLEFT", 0, 4);
			else
				group.num = 1;
				new = group;
				button:SetPoint("TOPLEFT", group:GetName(), "TOPLEFT", 0, -20);
			end
			new.next = button;
			button.group = group;
		end
	end
end

function CT_RA_SortByCustom()
	CT_RA_SORTTYPE = "custom";
	local groupnum = 1;
	local membernum = 1;
	for i = 1, 40, 1 do
		if ( i <= 8 ) then
			getglobal("CT_RAGroup" .. i).next = nil;
			getglobal("CT_RAGroup" .. i).num = 0;
			getglobal("CT_RAOptionsGroup" .. i .. "Label"):SetText("Group " .. i);
			getglobal("CT_RAMenuFrameBuffsNotifyDebuffsGroup" .. i .. "Text"):SetText("Group " .. i);
			getglobal("CT_RAMenuFrameBuffsNotifyGroup" .. i .. "Text"):SetText("Group " .. i);
		end
		getglobal("CT_RAMember" .. i).next = nil;
	end
	for i = 1, GetNumRaidMembers(), 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		if ( ( not CT_RA_HideOffline or online ) and ( CT_RA_Stats[name] or not CT_RA_HideNA ) ) then
			if ( CT_RA_CurrPositions[i] ) then
				subgroup = CT_RA_CurrPositions[i];
			else
				for y = 1, 8, 1 do
					if ( not getglobal("CT_RAGroup" .. y).num or getglobal("CT_RAGroup" .. y).num < 5 ) then
						subgroup = y;
						CT_RA_CurrPositions[i] = y;
						break;
					end
				end
			end
			local group = getglobal("CT_RAGroup" .. subgroup);
			getglobal(group:GetName() .. "GroupName"):SetText("Group " .. subgroup);

			local button = getglobal("CT_RAMember" .. i);
			button:ClearAllPoints();
			local new;
			if ( group.next and group.next ~= button ) then
				new = group;
				while ( new.next ) do
					if ( new.next ) then
						new = new.next;
					end
				end
				group.num = group.num + 1;
				button:ClearAllPoints();
				button:SetPoint("TOPLEFT", new:GetName(), "BOTTOMLEFT", 0, 4);
			else
				group.num = 1;
				new = group;
				button:ClearAllPoints();
				button:SetPoint("TOPLEFT", group:GetName(), "TOPLEFT", 0, -20);
			end
			new.next = button;
			button.group = group;
		end
	end
	CT_RA_UpdateCustomSorting();
end

function CT_RA_LinkDrag(frame, drag, point, relative, x, y)
	frame:ClearAllPoints();
	frame:SetPoint(point, drag:GetName(), relative, x, y);
end

CT_RA_ConvertedRaid = 1;
CT_RA_HasInvited = { };


function CT_RA_SendMTs()
	for k, v in CT_RA_MainTanks do
		if ( UnitName("player") == v ) then
			-- Player is a main tank
			CT_RA_AddMessage("SET " .. k .. " " .. v);
			if ( UnitExists("target") ) then
				local hasmana, friend, health, mana, name;
				if ( UnitManaMax("target") and UnitManaMax("target") > 0 and UnitPowerType("target") == 0 ) then
					hasmana = 1;
					mana = floor(UnitMana("target")/UnitManaMax("target")*100);
				else
					hasmana = 0;
					mana = -1;
				end
				health = floor(UnitHealth("target")/UnitHealthMax("target")*100);
				if ( UnitIsDead("target") ) then
					health = -1;
				end
				if ( UnitIsFriend("player", "target") ) then
					friend = 1;
				else
					friend = 0;
				end
				name = UnitName("target");
				CT_RA_AddMessage("TC " .. k .. " " .. hasmana .. " " .. friend .. " " .. health .. " " .. mana .. " " .. name);
				break;
			else
				CT_RA_AddMessage("LT " .. k);
			end
		end
	end
end

function CT_RA_UpdateFrame_OnUpdate(elapsed)
	this.update = this.update + elapsed;
	if ( this.update >= 1 ) then
		for k, v in CT_RA_BuffTimeLeft do
			if ( GetPlayerBuffTimeLeft(CT_RA_BuffTimeLeft[k][2]) and GetPlayerBuffTexture(CT_RA_BuffTimeLeft[k][2]) ) then
				if ( abs(CT_RA_BuffTimeLeft[k][1]-GetPlayerBuffTimeLeft(CT_RA_BuffTimeLeft[k][2])) >= 2 ) then
					local useless, useless, texture = string.find(GetPlayerBuffTexture(CT_RA_BuffTimeLeft[k][2]), "([%w_&]+)$");
					CT_RA_AddMessage("B " .. texture .. " " .. floor(GetPlayerBuffTimeLeft(CT_RA_BuffTimeLeft[k][2])+0.5) .. " " .. k);
				end
				CT_RA_BuffTimeLeft[k][1] = GetPlayerBuffTimeLeft(CT_RA_BuffTimeLeft[k][2]);
			end
		end
		for k, v in CT_RA_Stats do
			if ( v["Buffs"] ) then
				for key, val in v["Buffs"] do
					if ( type(val) == "table" and val[2] ) then
						val[2] = val[2] - 1;
					end
				end
			end
		end
		this.update = this.update - 1;
	end
	if ( this.time ) then
		this.time = this.time - elapsed;
		if ( this.time <= 0 ) then
			this.time = nil;
			if ( CT_RA_Level >= 1 ) then
				CT_RA_SendMTs();
			end
			CT_RA_SendStatus();
		end
	end
	if ( this.invite ) then
		this.invite = this.invite - elapsed;
		if ( this.invite <= 0 ) then
			if ( not CT_RA_ConvertedRaid ) then
				CT_RA_ConvertedRaid = 1;
				ConvertToRaid();
				this.invite = 3;
			else
				CT_RA_InviteGuild(CT_RA_MinLevel, CT_RA_MaxLevel);
				this.invite = nil;
			end
		end
	end
	if ( this.startinviting ) then
		this.startinviting = this.startinviting - elapsed;
		if ( this.startinviting <= 0 ) then
			this.startinviting = nil;
			CT_RA_HasInvited = { };
			if ( GetNumRaidMembers() == 0 ) then
				CT_RA_ConvertedRaid = nil;
			else
				CT_RA_ConvertedRaid = 1;
			end
			CT_RA_InviteGuild(CT_RA_MinLevel, CT_RA_MaxLevel);
			if ( CT_RA_MinLevel == CT_RA_MaxLevel ) then
				CT_RA_Print("<CTMod> Guild Members of level |c00FFFFFF" .. CT_RA_MinLevel .. "|r have been invited.", 1, 0.5, 0);
			else
				CT_RA_Print("<CTMod> Guild Members of levels |c00FFFFFF" .. CT_RA_MinLevel .. "|r to |c00FFFFFF" .. CT_RA_MaxLevel .. "|r have been invited.", 1, 0.5, 0);
			end
		end
	end
	if ( this.closeroster ) then
		this.closeroster = this.closeroster - elapsed;
		if ( this.closeroster <= 0 ) then
			HideUIPanel(FriendsFrame);
			this.closeroster = nil;
		end
	end
end
function CT_RA_UpdateFrame_OnEvent(event)
	if ( event == "PARTY_MEMBERS_CHANGED" ) then
		if ( not CT_RA_ConvertedRaid ) then
			this.invite = 3;
		end
	end
end


SlashCmdList["RAINVITE"] = function(msg)
	if ( not GetGuildInfo("player") ) then
		CT_RA_Print("<CTMod> You need to be in a guild to mass invite.");
		return;
	end
	if ( ( not CT_RA_Level or CT_RA_Level == 0 ) and GetNumRaidMembers() > 0 ) then
		CT_RA_Print("<CTMod> You must be promoted or raid leader to mass invite.", 1, 1, 0);
		return;
	end

	local useless, useless, min, max = string.find(msg, "^(%d+)-(%d+)$");
	min = tonumber(min);
	max = tonumber(max);
	if ( min and max ) then
		if ( min > max ) then
			local temp = min;
			min = max;
			max = temp;
		end
		if ( min < 1 ) then min = 1; end
		if ( max > 60 ) then max = 60; end
		if ( min == max ) then
			SendChatMessage("Raid invites are coming in 10 seconds for players level " .. min .. ", leave your groups.", "GUILD");
		else
			SendChatMessage("Raid invites are coming in 10 seconds for players level " .. min .. " to " .. max .. ", leave your groups.", "GUILD");
		end
		CT_RA_MinLevel = min;
		CT_RA_MaxLevel = max;
		CT_RA_UpdateFrame.startinviting = 10;
	else
		useless, useless, min = string.find(msg, "^(%d+)$");
		min = tonumber(min);
		if ( min ) then
			if ( min < 1 ) then min = 1; end
			if ( min > 60 ) then min = 60; end
			SendChatMessage("Raid invites are coming in 10 seconds for players level " .. min .. ", leave your groups.", "GUILD");
			CT_RA_MinLevel = min;
			CT_RA_MaxLevel = min;
			CT_RA_UpdateFrame.startinviting = 10;
		else
			CT_RA_Print("<CTMod> Syntax Error. Usage: |c00FFFFFF/rainvite level|r or |c00FFFFFF/rainvite minlevel-maxlevel|r.", 1, 0.5, 0);
			CT_RA_Print("<CTMod> This command mass invites everybody in the guild within the selected level range (or only selected level if maxlevel is omitted).", 1, 0.5, 0);
		end
	end
end

function CT_RA_InviteGuild(min, max)
	local offline = GetGuildRosterShowOffline();
	local selection = GetGuildRosterSelection();
	SetGuildRosterShowOffline(0);
	SetGuildRosterSelection(0);
	GetGuildRosterInfo(0);
	GuildRoster();
	local numInvites = 0;
	local numGuildMembers = GetNumGuildMembers();
	CT_RA_UpdateFrame.closeroster = 2;
	for i = 1, numGuildMembers, 1 do
		local name, rank, rankIndex, level, class, zone, group, note, officernote, online = GetGuildRosterInfo(i);
		if ( level >= min and level <= max and name ~= UnitName("player") and not CT_RA_HasInvited[i] and online ) then
			CT_RA_HasInvited[i] = 1;
			InviteByName(name);
			numInvites = numInvites + 1;
			if ( numInvites == 4 and not CT_RA_ConvertedRaid ) then 
				CT_RA_UpdateFrame.invite = 1.5;
				break;
			end
		end
	end
	SetGuildRosterShowOffline(offline);
	SetGuildRosterSelection(selection);
end

SlashCmdList["RAKEYWORD"] = function(msg)
	if ( msg == "off" ) then
		CT_RA_KeyWord = nil;
		CT_RA_Print("<CTMod> Keyword Inviting has been turned off.", 1, 0.5, 0);
	else
		CT_RA_KeyWord = msg;
		CT_RA_Print("<CTMod> Invite Keyword has been set to '|c00FFFFFF" .. msg .. "|r'. Use |c00FFFFFF/rakeyword off|r to turn Keyword Inviting off.", 1, 0.5, 0);
	end
end

SlashCmdList["RADISBAND"] = function(msg)
	if ( CT_RA_Level and CT_RA_Level >= 1 ) then
		CT_RA_Print("<CTMod> Disbanding raid...", 1, 0.5, 0);
		SendChatMessage("<CTMod> Disbanding raid on request by " .. UnitName("player") .. ".", "RAID");
		for i = 1, GetNumRaidMembers(), 1 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if ( online and rank <= CT_RA_Level and name ~= UnitName("player") ) then
				UninviteByName(name);
			end
		end
		CT_RA_AddMessage("DB");
		LeaveParty();
	else
		CT_RA_Print("<CTMod> You need to be raid leader or promoted to do that!", 1, 0.5, 0);
	end
end

SlashCmdList["RASHOW"] = function(msg)
	if ( msg == "all" ) then
		CT_RA_ShowGroups = { 1, 1, 1, 1, 1, 1, 1, 1 };
		CT_RACheckAllGroups:SetChecked(1);
		for i = 1, 8, 1 do
			getglobal("CT_RAOptionsGroupCB" .. i):SetChecked(1);
		end
	else
		if ( not CT_RA_HiddenGroups ) then return; end
		CT_RA_ShowGroups = CT_RA_HiddenGroups;
		CT_RA_HiddenGroups = nil;
		local num = 0;
		for k, v in CT_RA_ShowGroups do
			num = num + 1;
			getglobal("CT_RAOptionsGroupCB" .. k):SetChecked(1);
		end
		if ( num > 0 ) then
			CT_RACheckAllGroups:SetChecked(1);
		else
			CT_RACheckAllGroups:SetChecked(nil);
		end
	end
	CT_RA_UpdateRaidGroup();
end

SlashCmdList["RAHIDE"] = function(msg)
	CT_RA_HiddenGroups = CT_RA_ShowGroups;
	CT_RA_ShowGroups = { };
		CT_RACheckAllGroups:SetChecked(nil);
		for i = 1, 8, 1 do
			getglobal("CT_RAOptionsGroupCB" .. i):SetChecked(nil);
		end
	CT_RA_UpdateRaidGroup();
end

SLASH_RADISBAND1 = "/radisband";
SLASH_RAINVITE1 = "/rainvite";
SLASH_RAINVITE2 = "/rainv";
SLASH_RAKEYWORD1 = "/rakeyword";
SLASH_RAKEYWORD2 = "/rakw";
SLASH_RASHOW1 = "/rashow";
SLASH_RAHIDE1 = "/rahide";


-- Spam Control
CT_RA_Comm_HPChangeThreshold = 3;
CT_RA_Comm_MPChangeThreshold = 10;
CT_RA_Comm_MinMessageInterval = 0.1;
CT_RA_Comm_MTHPChangeTreshold = 3;
CT_RA_Comm_MTMPChangeTreshold = 10;
CT_RA_Comm_MessageQueue = { };

function CT_RA_ProcessMessages(elapsed)
	if ( this.elapsed > 0 ) then
		this.elapsed = this.elapsed - elapsed;
	end
	if ( this.elapsed <= 0 ) then
		if ( getn(CT_RA_Comm_MessageQueue) > 0 ) then
			CT_RA_SendMessageQueue();
			this.elapsed = CT_RA_Comm_MinMessageInterval;
		end
	end
end

function CT_RA_SendMessageQueue()
	local retstr = "";
	for key, val in CT_RA_Comm_MessageQueue do
		if ( strlen(retstr)+strlen(val)+1 > 255 ) then
			CT_RA_SendMessage(retstr, 1);
			retstr = "";
		end
		if ( retstr ~= "" ) then
			retstr = retstr .. "#";
		end
		retstr = retstr .. val;
	end
	if ( retstr ~= "" ) then
		CT_RA_SendMessage(retstr, 1);
	end
	CT_RA_Comm_MessageQueue = { };
end

function CT_RA_Split(msg, char)
	local arr = { };
	while (string.find(msg, char) ) do
		local iStart, iEnd = string.find(msg, char);
		tinsert(arr, strsub(msg, 1, iStart-1));
		msg = strsub(msg, iEnd+1, strlen(msg));
	end
	if ( strlen(msg) > 0 ) then
		tinsert(arr, msg);
	end
	return arr;
end

CT_RA_oldSpellTargetUnit = SpellTargetUnit;
function CT_RA_newSpellTargetUnit(unit)
	CT_RA_oldSpellTargetUnit(unit);
	CT_RA_SpellTarget = unit;
end
SpellTargetUnit = CT_RA_newSpellTargetUnit;

CT_RA_oldUseAction = UseAction;
function CT_RA_newUseAction(a1, a2, a3)
	CT_RA_oldUseAction(a1, a2, a3);
	if ( a3 and a3 == 1 ) then
		CT_RA_SpellTarget = "player";
	end
end
UseAction = CT_RA_newUseAction;

CT_RA_oldTargetUnit = TargetUnit;
function CT_RA_newTargetUnit(unit)
	if ( SpellIsTargeting() and SpellCanTargetUnit(unit) ) then
		CT_RA_SpellTarget = unit;
	end
	CT_RA_oldTargetUnit(unit);
end
TargetUnit = CT_RA_newTargetUnit;

function CT_RA_CastPartyCheck(button)
	local action_key = CastParty_BuildActionKey(button)

	if CastPartyPlayerConfig.key_bindings[_class] and CastPartyPlayerConfig.key_bindings[UnitClass("player")][action_key] then
		action = CastPartyPlayerConfig.key_bindings[UnitClass("player")][action_key]
	else
		action = CastPartyPlayerConfig.key_bindings[action_key]
	end
	-- execute a function action
	if type(action) == 'function' then
		action("target")
		return
	end
	if ( action == "CastParty_WoWDefaultClick" ) then
		return;
	end

	-- lookup a global function action
	local action_global = getglobal(action)
	if type(action_global) == 'function' then
		action_global("target")
		return
	end

	CastParty_CastSpell(action);
end
