--[[
Spell Alert
        Author:         Awen
        Version:        1.02
        Change Log :  
        	2005.03.21 "Renew" & "Regrowth" are no longer warned.
]]
-- Configuration variables
-- Local variables

sa_on = 1;
RegisterForSave("sa_on");

function SpellAlert_OnLoad()
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS");
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
	SlashCmdList["SpellAlertCOMMAND"] = SpellAlertHandler;
	SLASH_SpellAlertCOMMAND1 = "/spellalert";
	SpellAlert_print("SpellAlert 1.01 by Awen. Type /spellalert for usage.")
end

function SpellAlert_OnEvent()
	if (not sa_on) then
		return;
	end
	if (event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE") then
		local spell;
		for i, j in string.gfind(arg1, "(.+) begins to cast (.+).") do
			mob = i;
			spell = j;
		end
		if (mob and spell) then
			SpellAlert_banner(arg1);
		end
	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF") then
		local spell;
		for i, j in string.gfind(arg1, "(.+) begins to cast (.+).") do
			mob = i;
			spell = j;
		end
		if (mob and spell) then
			SpellAlert_banner(arg1);
		end
	elseif (event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS") then
		local mob;
		local spell;
		for i, j, k in string.gfind(arg1, "(.+) gains (.+) from (.+).") do
		end
		if (i and j and k) then
			return
		end
		for i, j in string.gfind(arg1, "(.+) gains (.+).") do
			mob = i;
			spell = j;
		end
		if (mob and spell) then
			if (spell == "Renew") then
				return
			end
			if (spell == "Regrowth") then
				return
			end
			SpellAlert_banner(arg1);
		end
	elseif (event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE") then
		local mob;
		local spell;
		for i, j in string.gfind(arg1, "(.+) begins to cast (.+).") do
			mob = i;
			spell = j;
		end
		if (mob and spell) then
			SpellAlert_banner(arg1);
		end
	elseif (event == "CHAT_MSG_EMOTE") then
		if (arg1) then
			SpellAlert_banner(arg1);
		end
	elseif (event == "CHAT_MSG_MONSTER_EMOTE") then
		local name = arg2;
		if (not name) then
			name = "nil";
		end
		if (arg1) then
			SpellAlert_banner(name .. " " .. arg1);
		end
	end
end

function SpellAlertHandler(msg)
	local text = msg;
	msg = string.lower(msg);

	-- check for 2 arguments first
	local command = msg;

	-- respond to commands
	if (string.lower(command) == "on") then
    	sa_on = 1;
    	SpellAlert_print("SpellAlert is enabled.");
    elseif (string.lower(command) == "off") then
    	sa_off = nil;
    	SpellAlert_print("SpellAlert is disabled.");
    else
    	SpellAlert_print("/spellalert [on/off]");
    end
end

function SpellAlert_banner(msg)
	UIErrorsFrame:AddMessage(msg, 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

function SpellAlert_print(msg)
	if (DEFAULT_CHAT_FRAME) then
		DEFAULT_CHAT_FRAME:AddMessage(msg);
	end
end