-------------------------------------------------------------------------------------------------
-- Azaziels Book of The Dead
-- v1.3
-- By Azaziel - Tiiiiiime is on my side.... yes it is
-------------------------------------------------------------------------------------------------
BINDING_HEADER_TFKILLSTATSHEADER = "Azaziel's Book of The Dead";
BINDING_NAME_TFKILLSTATS = "Toggle Book of The Dead";

tf_version="1.2";
tf_playerName=nil;
tf_playerRealm=nil;
tf_uiInitialized=false;
tf_pageSize=12;
tf_currentPage=1;

tf_targetType=nil;
tf_currentTargetName="";
tf_currentTargetLvl="";
tf_currentRace="";
tf_currentClass="";
tf_targetZone="";
tf_currentTab=1;
tf_pageType="";

tf_targetHistory = {};
tf_targetHistory.targetName = {};
tf_targetHistory.targetLvl = {};
tf_targetHistory.targetRace = {};
tf_targetHistory.targetClass = {};
tf_targetHistory.targetZone = {};
tf_targetHistory.targetType= {};

function TF_killStats_OnLoad()  
 this:RegisterEvent("UNIT_NAME_UPDATE");  
 this:RegisterEvent("PLAYER_TARGET_CHANGED");
 this:RegisterEvent("PLAYER_ENTER_COMBAT");
 this:RegisterEvent("PLAYER_LEAVE_COMBAT");
 this:RegisterEvent("UNIT_HEALTH");
 this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");  
 this:RegisterEvent("PLAYER_DEAD");
 
 UIPanelWindows["TFKillStatsFrame"] = {area = "left", pushable = 20};
 
 SlashCmdList["TF_resetPlayerData"] = TF_resetPlayerData;
 SLASH_TF_resetPlayerData1 = "/abotdresetdata";
 
 SlashCmdList["TF_syncPlayerData"] = TF_syncPlayerData;
 SLASH_TF_syncPlayerData1 = "/abotdsyncdata"; 
 
 SlashCmdList["TF_ToggleMiniMapIcon"] = TF_ToggleMiniMapIcon;
 SLASH_TF_ToggleMiniMapIcon1 = "/abotdtoggleicon";
 
 SlashCmdList["TF_toggleBook"] = TF_toggleBook;
 SLASH_TF_toggleBook1 = "/abotdtoggle"; 
 
 SlashCmdList["TF_help"] = TF_help;
 SLASH_TF_help1 = "/abotdhelp"; 

end

function TF_ToggleMiniMapIcon()
 if(TF_MiniMapBtn:IsVisible()) then
  TF_MiniMapBtn:Hide();
 else
  TF_MiniMapBtn:Show(); 
 end
end

function TF_toggleBook()
 TF_toggleUI();
end

function TF_help()
 setMessage("Azaziels Book of The Dead Version 1.3 Slash Command List");
 setMessage("-------------------------------------"); 
 setMessage("/abotdresetdata (Clears your book and sets all values back to zero.)");
 setMessage("/abotdtoggleicon (Toggles the book of the dead icon located by your player name.)");
 setMessage("/abotdtoggle (Toggles the book of the dead.)");  
end

function TF_killStats_controller(event)   
 if(event=="UNIT_HEALTH") then 
  checkForDeath();    
 elseif(event == "PLAYER_ENTER_COMBAT" or event=="CHAT_MSG_SPELL_SELF_DAMAGE") then     
  TF_setCombatTargetData();
  checkForDeath();      
 elseif(event == "PLAYER_LEAVE_COMBAT") then
  -- Might need to set target history to nil 
 elseif(event == "UNIT_NAME_UPDATE") then  
  TF_killStats_Initialize(event);
 elseif(event == "PLAYER_DEAD") then  
  TF_recordDeath(); 
  TF_clearCombatTargetData(); 
 elseif(event == "PLAYER_TARGET_CHANGED" and UnitExists("target")~= nil and UnitIsEnemy("player","target")) then  
  if(UnitHealth("player") > 0 and UnitIsCorpse("player") == nil and UnitIsDeadOrGhost("player") == nil) then 
   setTargetHistory();  
  end 
 end 
end

function setTargetHistory() 
 local idx=getTargetHistoryLength();
 tf_targetHistory.targetName[idx]=UnitName("target");
 tf_targetHistory.targetLvl[idx]=TF_getTargetLevel();
 tf_targetHistory.targetRace[idx]=TF_getTargetRace();
 tf_targetHistory.targetClass[idx]=UnitClass("target");
 tf_targetHistory.targetZone[idx]=GetZoneText(); 
 tf_targetHistory.targetType[idx]=TF_getTargetType();   
end 

function clearTargetHistory()
 tf_targetHistory = {};
 tf_targetHistory.targetName = {};
 tf_targetHistory.targetLvl = {};
 tf_targetHistory.targetRace = {};
 tf_targetHistory.targetClass = {};
 tf_targetHistory.targetZone = {};
 tf_targetHistory.targetType= {};
end

function getTargetHistoryLength()
 return table.getn(tf_targetHistory.targetName)*1+1;
end

function checkForDeath() 
 if(UnitHealth("target") == 0 or UnitIsCorpse("target") or UnitIsDeadOrGhost("target")) then              
  if(UnitName("target") == tf_currentTargetName) then       
   if(tf_targetType=="pvp") then     
    TF_addPvPRecordWin();
	TF_clearCombatTargetData(); 	
   elseif(tf_targetType=="pve" or tf_targetType=="elitepve") then        
    TF_addPvERecordWin();
	TF_clearCombatTargetData(); 	
   elseif(tf_targetType=="duel") then
    -- Add Duel Win	  	
   end	  
  end   
 end   
end

function TF_recordDeath() 
 if(tf_targetType == "pvp") then
  TF_addPvPRecordLoss();
  TF_clearCombatTargetData();  
 elseif(tf_targetType=="pve" or tf_targetType=="elitepve") then    
  TF_addPvERecordLoss();
  TF_clearCombatTargetData();  
 else
  TF_setCombatTargetFromHistory();
  if(tf_targetType == "pvp") then
   TF_addPvPRecordLoss();
   TF_clearCombatTargetData();  
  elseif(tf_targetType=="pve" or tf_targetType=="elitepve") then    
   TF_addPvERecordLoss();
   TF_clearCombatTargetData();  
  elseif(tf_targetType == "duel") then 
   -- Add Duel Loss
  end   
 end
 clearTargetHistory();	
end

function TF_setCombatTargetFromHistory()
 idx=table.getn(tf_targetHistory.targetName);
 tf_currentTargetName=tf_targetHistory.targetName[idx];
 tf_currentTargetLvl=tf_targetHistory.targetLvl[idx];
 tf_currentRace=tf_targetHistory.targetRace[idx];
 tf_currentClass=tf_targetHistory.targetClass[idx];
 tf_targetZone=tf_targetHistory.targetZone[idx];
 tf_yourLvl=UnitLevel("player"); 
 tf_targetType=tf_targetHistory.targetType[idx]; 
end

function TF_killStats_Initialize(event)
 if(TF_getUiInitialized()==false) then
  if(TF_getPlayerRealm()==nil) then
   TF_setPlayerRealm();
  end
 
  if(event == "UNIT_NAME_UPDATE") then
   if(TF_getPlayerName()==nil or TF_getPlayerName()==UNKNOWNOBJECT or TF_getPlayerName()==UKNOWNBEING or TF_getPlayerName()=="Unknown Entity") then  
    TF_setPlayerName();
   end 
  end
 
  if(TF_getPlayerRealm()~=nil) then
   if(TF_getPlayerName()~=nil and TF_getPlayerName()~=UNKNOWNOBJECT and TF_getPlayerName()~=UKNOWNBEING and TF_getPlayerName()~="Unknown Entity") then  
    
    if(TF_addOnDataExists() == false) then
	 TF_initializeAddOnData();
	end
	
	if(TF_realmDataExists() == false) then
	 TF_initializeRealmData();
	end 
	
	if(TF_playerDataExists() == false) then
	 TF_initializePlayerData();	 
	end
		
	TF_setFactionLabels();
	TF_setUiInitialized(true);		
   end
  end 
 end 
end

function TF_setFactionLabels()
 if(TF_getFaction("player") == "Horde") then
  TF_classLabel_8:SetText("Paladin:");
  TF_racialLabel_1:SetText("Human:");
  TF_racialLabel_2:SetText("Night Elf:");
  TF_racialLabel_3:SetText("Dwarf:");
  TF_racialLabel_4:SetText("Gnome:");  
 elseif(TF_getFaction("player") == "Alliance") then
  TF_classLabel_8:SetText("Shaman:")
  TF_racialLabel_1:SetText("Orc:");
  TF_racialLabel_2:SetText("Tauren:");
  TF_racialLabel_3:SetText("Undead:");
  TF_racialLabel_4:SetText("Troll:");  
 end 
end

function TF_getVersion()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].version;
end

function TF_toggleUI()
 if(TF_getUiInitialized() == true) then   
  if(TFKillStatsFrame:IsVisible()) then  
   PlaySound("igSpellBookClose");
   TF_hideAllFrames();     
   --TFKillStatsFrame:Hide();
   HideUIPanel(TFKillStatsFrame);   
  else       
   PlaySound("igSpellBookOpen");
   TF_disablePaging();
   TF_hideAllFrames();    
   ShowUIPanel(TFKillStatsFrame);       
   --TFKillStatsFrame:Show();   
   TF_displayGeneralStats(); 
  end 
 else
  setMessage("Azaziel's Book of The Dead Failed to Initialize.");
 end   
end  

function TF_displayGeneralStats()
 TF_disablePaging();
 TF_hideAllFrames();
 tf_currentPage=1;
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of 1");
 GeneralPvPStatsFrame:Show(); 
 TF_generalValue_1:SetText(TF_getKillCount());
 TF_generalValue_2:SetText(TF_getKilledCount());
 TF_generalValue_3:SetText(TF_getCurrentWinStreak());
 TF_generalValue_4:SetText(TF_getLongestWinStreak());
 TF_generalValue_5:SetText(TF_getAvgLvlOfVictims());
 TF_generalValue_6:SetText(TF_getTotalSurvPercent().."%");
 TF_generalValue_7:SetText(TF_getTotalPveKills());
 TF_generalValue_8:SetText(TF_getTotalPveDeaths());
 TF_generalValue_9:SetText(TF_getTotalPveEliteKills());
 TF_generalValue_10:SetText(TF_getTotalPveEliteDeaths()); 
end

function TF_displayClassStats()
 TF_disablePaging()
 TF_hideAllFrames();
 tf_currentPage=1;
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of 1");
 ClassPvPStatsFrame:Show();
 TF_classKills_1:SetText(TF_getClassKillCount("Druid"));
 TF_classDeaths_1:SetText(TF_getClassKilledCount("Druid"));
 TF_classSurv_1:SetText(TF_getClassSurvPercent("Druid").."%"); 	
 TF_classKills_2:SetText(TF_getClassKillCount("Mage"));
 TF_classDeaths_2:SetText(TF_getClassKilledCount("Mage"));
 TF_classSurv_2:SetText(TF_getClassSurvPercent("Mage").."%");
 TF_classKills_3:SetText(TF_getClassKillCount("Priest"));
 TF_classDeaths_3:SetText(TF_getClassKilledCount("Priest"));
 TF_classSurv_3:SetText(TF_getClassSurvPercent("Priest").."%");
 TF_classKills_4:SetText(TF_getClassKillCount("Rogue"));
 TF_classDeaths_4:SetText(TF_getClassKilledCount("Rogue"));
 TF_classSurv_4:SetText(TF_getClassSurvPercent("Rogue").."%");
 TF_classKills_5:SetText(TF_getClassKillCount("Warlock"));
 TF_classDeaths_5:SetText(TF_getClassKilledCount("Warlock"));
 TF_classSurv_5:SetText(TF_getClassSurvPercent("Warlock").."%");
 TF_classKills_6:SetText(TF_getClassKillCount("Warrior"));
 TF_classDeaths_6:SetText(TF_getClassKilledCount("Warrior"));
 TF_classSurv_6:SetText(TF_getClassSurvPercent("Warrior").."%");
 TF_classKills_7:SetText(TF_getClassKillCount("Hunter"));
 TF_classDeaths_7:SetText(TF_getClassKilledCount("Hunter"));
 TF_classSurv_7:SetText(TF_getClassSurvPercent("Hunter").."%");
 if(TF_getFaction("player") == "Horde") then
  TF_classKills_8:SetText(TF_getClassKillCount("Paladin"));
  TF_classDeaths_8:SetText(TF_getClassKilledCount("Paladin"));
  TF_classSurv_8:SetText(TF_getClassSurvPercent("Paladin").."%");
 elseif(TF_getFaction("player") == "Alliance") then
  TF_classKills_8:SetText(TF_getClassKillCount("Shaman"));
  TF_classDeaths_8:SetText(TF_getClassKilledCount("Shaman"));
  TF_classSurv_8:SetText(TF_getClassSurvPercent("Shaman").."%");
 end
end

function TF_displayRacialStats() 
 TF_disablePaging();
 TF_hideAllFrames();
 tf_currentPage=1;
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of 1");
 RacialPvPStatsFrame:Show();
 if(TF_getFaction("player") == "Horde") then
  TF_racialKills_1:SetText(TF_getRaceKillCount("Human"));
  TF_racialDeaths_1:SetText(TF_getRaceKilledCount("Human"));
  TF_racialSurv_1:SetText(TF_getRaceSurvPercent("Human").."%");
  TF_racialKills_2:SetText(TF_getRaceKillCount("Night Elf"));
  TF_racialDeaths_2:SetText(TF_getRaceKilledCount("Night Elf"));
  TF_racialSurv_2:SetText(TF_getRaceSurvPercent("Night Elf").."%"); 
  TF_racialKills_3:SetText(TF_getRaceKillCount("Dwarf"));
  TF_racialDeaths_3:SetText(TF_getRaceKilledCount("Dwarf"));
  TF_racialSurv_3:SetText(TF_getRaceSurvPercent("Dwarf").."%"); 
  TF_racialKills_4:SetText(TF_getRaceKillCount("Gnome"));
  TF_racialDeaths_4:SetText(TF_getRaceKilledCount("Gnome"));
  TF_racialSurv_4:SetText(TF_getRaceSurvPercent("Gnome").."%"); 
 elseif(TF_getFaction("player") == "Alliance") then 
  TF_racialKills_1:SetText(TF_getRaceKillCount("Orc"));
  TF_racialDeaths_1:SetText(TF_getRaceKilledCount("Orc"));
  TF_racialSurv_1:SetText(TF_getRaceSurvPercent("Orc").."%"); 
  TF_racialKills_2:SetText(TF_getRaceKillCount("Tauren"));
  TF_racialDeaths_2:SetText(TF_getRaceKilledCount("Tauren"));
  TF_racialSurv_2:SetText(TF_getRaceSurvPercent("Tauren").."%"); 
  TF_racialKills_3:SetText(TF_getRaceKillCount("Undead"));
  TF_racialDeaths_3:SetText(TF_getRaceKilledCount("Undead"));
  TF_racialSurv_3:SetText(TF_getRaceSurvPercent("Undead").."%");
  TF_racialKills_4:SetText(TF_getRaceKillCount("Troll"));
  TF_racialDeaths_4:SetText(TF_getRaceKilledCount("Troll"));
  TF_racialSurv_4:SetText(TF_getRaceSurvPercent("Troll").."%");
 end 
end

function TF_displayVictimList()
 TF_setPageType("victim");
 TF_hideAllFrames();
 VictimListPvPFrame:Show();
 tf_currentPage=1;
 TF_clearPage();
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of "..TF_getMaxPages()); 
 TF_displayPage(tf_currentPage);
 TF_setPaging();  
end

function TF_displayRevengeList()
 TF_setPageType("death");
 TF_hideAllFrames();
 DeathListPvPFrame:Show();
 tf_currentPage=1;
 TF_clearPage();
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of "..TF_getMaxPages()); 
 TF_displayPage(tf_currentPage);
 TF_setPaging(); 
end


function TF_displayAbout()
 TF_disablePaging();
 TF_hideAllFrames();
 tf_currentPage=1;
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of 1");
 AboutFrame:Show();
end

function TF_hideAllFrames()
 GeneralPvPStatsFrame:Hide();
 ClassPvPStatsFrame:Hide();
 RacialPvPStatsFrame:Hide();
 VictimListPvPFrame:Hide();
 DeathListPvPFrame:Hide();
 AboutFrame:Hide();
end

function TF_setPageType(x)
 tf_pageType=x;
end

function TF_getPageType()
 return tf_pageType;
end

function TF_disablePaging()
 TF_killStatsNextPageButton:Disable();
 TF_killStatsPrevPageButton:Disable();
end

function TF_PrevPageButton_OnClick()
 PlaySound("igAbiliityPageTurn");
 tf_currentPage=(tf_currentPage-1);
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of "..TF_getMaxPages()); 
 TF_displayPage(tf_currentPage);  
 TF_setPaging();
end 

function TF_NextPageButton_OnClick()
 PlaySound("igAbiliityPageTurn");
 tf_currentPage=(tf_currentPage+1);
 TFKillStatsPageText:SetText("Page "..tf_currentPage.." of "..TF_getMaxPages()); 
 TF_displayPage(tf_currentPage);  
 TF_setPaging();
end

function TF_setPlayerName()
 tf_playerName=UnitName("player");
end

function TF_getPlayerName()
 return tf_playerName;
end 

function TF_setPlayerRealm()
 tf_playerRealm=GetCVar("realmName");
end

function TF_getPlayerRealm()
 return tf_playerRealm;
end 

function TF_setUiInitialized(x)
 tf_uiInitialized=x;
end

function TF_getUiInitialized()
 return tf_uiInitialized;
end 

function TF_getTotalPvPKills()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_wins*1;
end

function TF_addOnDataExists()
 if(tf_user_data==nil) then 
  return false;
 else
  return true;
 end  
end

function TF_initializeAddOnData()
 tf_user_data={ }; 
end

function TF_realmDataExists()
 if(tf_user_data[TF_getPlayerRealm()]==nil) then
  return false;
 else
  return true; 
 end
end

function TF_initializeRealmData()
 tf_user_data[TF_getPlayerRealm()]={ };
end

function TF_playerDataExists()
 if(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()]==nil) then
  return false;
 else
  return true; 
 end
end

function TF_initializePlayerData()
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()]={ }; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction = TF_getFaction("player"); 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].version="2.2";  
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_current_win_streak = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_longest_win_streak = "0";  
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_level_sum = "0"; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_loss = "0"; 
 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyRace = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyClass = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledYourLvl = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledZone = { }; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledDate = { }; 
 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName = { }; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyRace = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyClass = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByYourLvl = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByZone = { }; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal = { };
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByDate = { }; 
 
 TF_initializeClassData();
 TF_initializeRaceData();
 setMessage("User data for the book of the dead initialized.");
end 

function TF_initializeClassData()
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_loss = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_loss = "0"; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_wins = "0"; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_loss = "0";  
 if(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction == "Horde") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_loss = "0";
 elseif(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction == "Alliance") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_loss = "0";
 end
end

function TF_initializeRaceData()
 if(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction == "Horde") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_loss = "0"; 
 elseif(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction == "Alliance") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_wins = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_loss = "0";
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_loss = "0";    
 end 
end

function TF_getFaction(type)
 if(type == "player") then
  if(UnitRace("player") == "Troll" or UnitRace("player") == "Orc" or UnitRace("player") == "Tauren"  or UnitRace("player") == "Undead") then
   return "Horde";
  else
   return "Alliance"; 
  end
 else
  if(UnitRace("target") == "Troll" or UnitRace("target") == "Orc" or UnitRace("target") == "Tauren"  or UnitRace("target") == "Undead") then
   return "Horde";
  else
   return "Alliance"; 
  end 
 end 
end

function TF_resetPlayerData()
 TF_initializePlayerData();
end

function TF_syncPlayerData()
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_wins = "0";
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_loss = "0"; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_level_sum = "0"; 
 TF_initializeClassData();
 TF_initializeRaceData(); 
 local idx=1; 
 do  
   if idx >= TF_getPvPKillsRecordCount() then end
   while(idx <= TF_getPvPKillsRecordCount()) do    
    TF_setKillCount((TF_getKillCount()*1+(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[idx]*1))); 
	tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_level_sum=(TF_getLevelTotal() + (tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[idx]*tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[idx]));
	TF_setClassKillCount((TF_getClassKillCount(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyClass[idx])*1+tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[idx]),tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyClass[idx]);
    TF_setRaceKillCount((TF_getRaceKillCount(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyRace[idx])*1+tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[idx]),tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyRace[idx]);         	   
	idx=(idx+1);
   end
 end  
 
 idx=1;
 do  
   if idx >= TF_getPvPLossRecordCount() then end
   while(idx <= TF_getPvPLossRecordCount()) do    
    TF_setKilledCount((TF_getKilledCount()*1+(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[idx]*1))); 
	
	TF_setClassKilledCount((TF_getClassKilledCount(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyClass[idx])*1+tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[idx]),tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyClass[idx]);
    TF_setRaceKilledCount((TF_getRaceKilledCount(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyRace[idx])*1+tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[idx]),tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyRace[idx]);         	   
	idx=(idx+1);
   end
 end
 setMessage("Totals Recalculated."); 
end

function TF_displayPage(currentPage)  
 TF_clearPage();  
 local killIdx=(((tf_pageSize*currentPage)-tf_pageSize)+1);   
 if(TF_getPageType() == "victim") then
  for i=1,tf_pageSize do
   if(killIdx > TF_getPvPKillsRecordCount()) then break; end
   TF_setPageLine(i,killIdx);
   killIdx=(killIdx+1);
  end
 else  
  for i=1,tf_pageSize do
   if(killIdx > TF_getPvPLossRecordCount()) then break; end   
   TF_setPageLine(i,killIdx);
   killIdx=(killIdx+1);
  end 
 end 
end 

function TF_setPageLine(pageLine,killIdx)
 if(TF_getPageType()=="victim") then   
  if(pageLine==1) then
   TF_killLvl_line_1:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_1:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_1:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==2) then
   TF_killLvl_line_2:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_2:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_2:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==3) then
   TF_killLvl_line_3:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_3:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_3:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==4) then
   TF_killLvl_line_4:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_4:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_4:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==5) then
   TF_killLvl_line_5:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_5:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_5:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==6) then
   TF_killLvl_line_6:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_6:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_6:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==7) then
   TF_killLvl_line_7:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_7:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_7:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==8) then
   TF_killLvl_line_8:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_8:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_8:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==9) then
   TF_killLvl_line_9:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_9:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_9:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==10) then
   TF_killLvl_line_10:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_10:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_10:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==11) then
   TF_killLvl_line_11:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_11:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_11:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  elseif(pageLine==12) then
   TF_killLvl_line_12:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[killIdx].."]");
   TF_killName_line_12:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[killIdx]);
   TF_killTotal_line_12:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[killIdx]..")");
  end
 else  
  if(pageLine==1) then   
   TF_deathLvl_line_1:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_1:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_1:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==2) then
   TF_deathLvl_line_2:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_2:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_2:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==3) then
   TF_deathLvl_line_3:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_3:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_3:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==4) then
   TF_deathLvl_line_4:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_4:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_4:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==5) then
   TF_deathLvl_line_5:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_5:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_5:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==6) then
   TF_deathLvl_line_6:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_6:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_6:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==7) then
   TF_deathLvl_line_7:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_7:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_7:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==8) then
   TF_deathLvl_line_8:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_8:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_8:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==9) then
   TF_deathLvl_line_9:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_9:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_9:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==10) then
   TF_deathLvl_line_10:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_10:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_10:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==11) then
   TF_deathLvl_line_11:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_11:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_11:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  elseif(pageLine==12) then
   TF_deathLvl_line_12:SetText("["..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[killIdx].."]");
   TF_deathName_line_12:SetText(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[killIdx]);
   TF_deathTotal_line_12:SetText("("..tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[killIdx]..")");
  end
 end 
end

function TF_clearPage()
 if(TF_getPageType() == "victim") then
  TF_killLvl_line_1:SetText("");
  TF_killName_line_1:SetText("");
  TF_killTotal_line_1:SetText("");
  TF_killLvl_line_2:SetText("");
  TF_killName_line_2:SetText("");
  TF_killTotal_line_2:SetText("");
  TF_killLvl_line_3:SetText("");
  TF_killName_line_3:SetText("");
  TF_killTotal_line_3:SetText("");
  TF_killLvl_line_4:SetText("");
  TF_killName_line_4:SetText("");
  TF_killTotal_line_4:SetText("");
  TF_killLvl_line_5:SetText("");
  TF_killName_line_5:SetText("");
  TF_killTotal_line_5:SetText("");
  TF_killLvl_line_6:SetText("");
  TF_killName_line_6:SetText("");
  TF_killTotal_line_6:SetText("");
  TF_killLvl_line_7:SetText("");
  TF_killName_line_7:SetText("");
  TF_killTotal_line_7:SetText("");
  TF_killLvl_line_8:SetText("");
  TF_killName_line_8:SetText("");
  TF_killTotal_line_8:SetText("");
  TF_killLvl_line_9:SetText("");
  TF_killName_line_9:SetText("");
  TF_killTotal_line_9:SetText("");
  TF_killLvl_line_10:SetText("");
  TF_killName_line_10:SetText("");
  TF_killTotal_line_10:SetText("");
  TF_killLvl_line_11:SetText("");
  TF_killName_line_11:SetText("");
  TF_killTotal_line_11:SetText("");
  TF_killLvl_line_12:SetText("");
  TF_killName_line_12:SetText("");
  TF_killTotal_line_12:SetText("");
 else
  TF_deathLvl_line_1:SetText("");
  TF_deathName_line_1:SetText("");
  TF_deathTotal_line_1:SetText("");
  TF_deathLvl_line_2:SetText("");
  TF_deathName_line_2:SetText("");
  TF_deathTotal_line_2:SetText("");
  TF_deathLvl_line_3:SetText("");
  TF_deathName_line_3:SetText("");
  TF_deathTotal_line_3:SetText("");
  TF_deathLvl_line_4:SetText("");
  TF_deathName_line_4:SetText("");
  TF_deathTotal_line_4:SetText("");
  TF_deathLvl_line_5:SetText("");
  TF_deathName_line_5:SetText("");
  TF_deathTotal_line_5:SetText("");
  TF_deathLvl_line_6:SetText("");
  TF_deathName_line_6:SetText("");
  TF_deathTotal_line_6:SetText("");
  TF_deathLvl_line_7:SetText("");
  TF_deathName_line_7:SetText("");
  TF_deathTotal_line_7:SetText("");
  TF_deathLvl_line_8:SetText("");
  TF_deathName_line_8:SetText("");
  TF_deathTotal_line_8:SetText("");
  TF_deathLvl_line_9:SetText("");
  TF_deathName_line_9:SetText("");
  TF_deathTotal_line_9:SetText("");
  TF_deathLvl_line_10:SetText("");
  TF_deathName_line_10:SetText("");
  TF_deathTotal_line_10:SetText("");
  TF_deathLvl_line_11:SetText("");
  TF_deathName_line_11:SetText("");
  TF_deathTotal_line_11:SetText("");
  TF_deathLvl_line_12:SetText("");
  TF_deathName_line_12:SetText("");
  TF_deathTotal_line_12:SetText("");
 end
end 

function setMessage(msgString)
 DEFAULT_CHAT_FRAME:AddMessage(msgString);
end

function TF_getKillCount()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_wins*1;
end

function TF_setKillCount(x)
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_wins=x;
end

function TF_getKilledCount()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_loss*1;
end

function TF_setKilledCount(x)
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_loss=x;
end

function TF_getPvPKillsRecordCount()
 return table.getn(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName);
end

function TF_getPvPLossRecordCount()
 return table.getn(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName);
end

function TF_setClassKillCount(x,class)
 if(class == "Druid") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_wins=x;
 elseif(class == "Hunter") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_wins=x;
 elseif(class == "Mage") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_wins=x;
 elseif(class == "Paladin") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_wins=x;
 elseif(class == "Priest") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_wins=x;
 elseif(class == "Rogue") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_wins=x;
 elseif(class == "Shaman") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_wins=x;
 elseif(class == "Warlock") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_wins=x;
 elseif(class == "Warrior") then 
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_wins=x;
 end 
end

function TF_getClassKillCount(class)
 if(class == "Druid") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_wins*1;
 elseif(class == "Hunter") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_wins*1;
 elseif(class == "Mage") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_wins*1;
 elseif(class == "Paladin") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_wins*1;
 elseif(class == "Priest") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_wins*1;
 elseif(class == "Rogue") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_wins*1;
 elseif(class == "Shaman") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_wins*1;
 elseif(class == "Warlock") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_wins*1;
 elseif(class == "Warrior") then 
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_wins*1;
 end 
end

function TF_setClassKilledCount(x,class)
 if(class == "Druid") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_loss=x;
 elseif(class == "Hunter") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_loss=x;
 elseif(class == "Mage") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_loss=x;
 elseif(class == "Paladin") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_loss=x;
 elseif(class == "Priest") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_loss=x;
 elseif(class == "Rogue") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_loss=x;
 elseif(class == "Shaman") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_loss=x;
 elseif(class == "Warlock") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_loss=x;
 elseif(class == "Warrior") then 
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_loss=x;
 end 
end

function TF_getClassKilledCount(class)
 if(class == "Druid") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_druid_loss*1;
 elseif(class == "Hunter") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_hunter_loss*1;
 elseif(class == "Mage") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_mage_loss*1;
 elseif(class == "Paladin") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_paladin_loss*1;
 elseif(class == "Priest") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_priest_loss*1;
 elseif(class == "Rogue") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_rogue_loss*1;
 elseif(class == "Shaman") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_shaman_loss*1;
 elseif(class == "Warlock") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warlock_loss*1;
 elseif(class == "Warrior") then 
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_warrior_loss*1;
 end 
end

function TF_getClassSurvPercent(class)
 local total=0;
 local pct=0;
 total = ((TF_getClassKillCount(class)*1)+(TF_getClassKilledCount(class)*1)); 
 if(total ~= 0) then
  pct = math.floor((TF_getClassKillCount(class)/total)*100);
 end 
 return pct; 
end

function TF_setRaceKillCount(x,race)
 if(race == "Human") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_wins=x;
 elseif(race == "Night Elf") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_wins=x;
 elseif(race == "Dwarf") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_wins=x;
 elseif(race == "Gnome") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_wins=x;
 elseif(race == "Orc") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_wins=x;
 elseif(race == "Troll") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_wins=x;
 elseif(race == "Tauren") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_wins=x;
 elseif(race == "Undead") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_wins=x; 
 end 
end

function TF_getRaceKillCount(race) 
 if(race == "Human") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_wins*1;
 elseif(race == "Night Elf") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_wins*1;
 elseif(race == "Dwarf") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_wins*1;
 elseif(race == "Gnome") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_wins*1;
 elseif(race == "Orc") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_wins*1;
 elseif(race == "Troll") then  
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_wins*1;
 elseif(race == "Tauren") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_wins*1;
 elseif(race == "Undead") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_wins*1; 
 end 
end

function TF_setRaceKilledCount(x,race) 
 if(race == "Human") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_loss=x;
 elseif(race == "Night Elf") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_loss=x;
 elseif(race == "Dwarf") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_loss=x;
 elseif(race == "Gnome") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_loss=x;
 elseif(race == "Orc") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_loss=x;
 elseif(race == "Troll") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_loss=x;
 elseif(race == "Tauren") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_loss=x;
 elseif(race == "Undead") then
  tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_loss=x; 
 end 
end

function TF_getRaceKilledCount(race)
 if(race == "Human") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_human_loss*1;
 elseif(race == "Night Elf") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_nightElf_loss*1;
 elseif(race == "Dwarf") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_dwarf_loss*1;
 elseif(race == "Gnome") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_gnome_loss*1;
 elseif(race == "Orc") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_orc_loss*1;
 elseif(race == "Troll") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_troll_loss*1;
 elseif(race == "Tauren") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_tauren_loss*1;
 elseif(race == "Undead") then
  return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_undead_loss*1; 
 end 
end

function TF_getRaceSurvPercent(race)
 local total=0;
 local pct=0;
 total = ((TF_getRaceKillCount(race)*1)+(TF_getRaceKilledCount(race)*1)); 
 if(total ~= 0) then
  pct = math.floor((TF_getRaceKillCount(race)/total)*100);
 end 
 return pct; 
end

function TF_getAvgLvlOfVictims()
 local average=0;
 if(TF_getLevelTotal() ~= 0) then
  average = math.ceil(TF_getLevelTotal()/TF_getKillCount()); 
 end
 return average;
end

function TF_getTotalSurvPercent()
 local pct = 0;
 local total = ((TF_getKillCount()*1)+(TF_getKilledCount()*1));  
 if(total ~= 0) then
  pct = math.floor((TF_getKillCount()/total)*100); 
 end 
 return pct; 
end

function TF_getMaxPages()
 local totalPages=1;
 if(TF_getPageType() == "victim") then
  totalPages=ceil(TF_getPvPKillsRecordCount()/tf_pageSize);  
 else   
  totalPages=ceil(TF_getPvPLossRecordCount()/tf_pageSize);
 end 
 if(totalPages < 1) then
   return 1;
 else 
  return totalPages;
 end
end

function TF_setPaging() 
 if(TF_getPageType() == "victim") then
  if(tf_currentPage < (TF_getPvPKillsRecordCount()/tf_pageSize)) then
   TF_killStatsNextPageButton:Enable();
  else
   TF_killStatsNextPageButton:Disable(); 
  end
 else
  if(tf_currentPage < (TF_getPvPLossRecordCount()/tf_pageSize)) then
   TF_killStatsNextPageButton:Enable();
  else
   TF_killStatsNextPageButton:Disable(); 
  end
 end 

 if(tf_currentPage==1) then
  TF_killStatsPrevPageButton:Disable();
 else
  TF_killStatsPrevPageButton:Enable();    	     	
 end 
end

function TF_getTargetType()
 if(UnitIsPlayer("target")) then 
  if(UnitIsEnemy("target", "player")) then
   if(TF_getFaction("target") ~= tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].player_faction) then
    return "pvp";  
   else
    return "duel";
   end		
  else
   return "friendly"; 
  end  
 elseif(UnitIsPlusMob("target")) then
  return "elitepve"; 
 else
  return "pve";
 end 
end

function TF_setCombatTargetData() 
 if(tf_currentTargetName ~= UnitName("target")) then   
  tf_currentTargetName=UnitName("target");
  tf_currentTargetLvl=TF_getTargetLevel();
  tf_currentRace=TF_getTargetRace();
  tf_currentClass=UnitClass("target"); 
  tf_targetZone=GetZoneText(); 
  tf_yourLvl=UnitLevel("player"); 
  tf_targetType=TF_getTargetType();   
 end  
end

function TF_getTargetLevel()
 local lvl=0;
 if(UnitLevel("target") < 1) then
  lvl=((UnitLevel("player")*1) + 10)
  if(lvl > 60) then
   lvl = 60;
  end 
 else
  lvl=UnitLevel("target");
 end 
 return lvl;
end

function TF_getTargetRace()
 local race="";
 if(UnitRace("target")) then
  race=UnitRace("target");
 else
  race="Unknown";
 end
 return race;  
end

function TF_clearCombatTargetData()
 tf_currentTargetName="";
 tf_currentTargetLvl="";
 tf_currentRace="";
 tf_currentClass=""; 
 tf_targetZone=""; 
 tf_yourLvl=""; 
 tf_targetType=""; 
end

function TF_addPvPRecordWin() 
 local pvpIdx=TF_getKillIndex(); 
 local enemyKillTotal=1 
 if(pvpIdx <= TF_getPvPKillsRecordCount()) then  
  enemyKillTotal=(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[pvpIdx]*1+1);    
 end  
 TF_setKillCount((TF_getKillCount()*1+1));  
 TF_setCurrentWinStreak((TF_getCurrentWinStreak()*1+1)); 
 if(TF_getCurrentWinStreak() > TF_getLongestWinStreak()) then
  TF_setLongestWinStreak(TF_getCurrentWinStreak());
 end  
 TF_setClassKillCount((TF_getClassKillCount(tf_currentClass)*1+1),tf_currentClass);
 TF_setRaceKillCount((TF_getRaceKillCount(tf_currentRace)*1+1),tf_currentRace); 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[pvpIdx] = tf_currentTargetName;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyLvl[pvpIdx] = tf_currentTargetLvl;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyRace[pvpIdx] = tf_currentRace;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyClass[pvpIdx] = tf_currentClass; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyTotal[pvpIdx] = enemyKillTotal;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledYourLvl[pvpIdx] = tf_yourLvl;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledZone[pvpIdx] = tf_targetZone; 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledDate[pvpIdx] = date();
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_level_sum = (TF_getLevelTotal() + tf_currentTargetLvl); 
end

function TF_getLevelTotal()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_level_sum*1;
end

function TF_addPvPRecordLoss() 
 local pvpIdx=TF_getKilledIndex();
 local enemyKilledByTotal=1; 
 if(pvpIdx <= TF_getPvPLossRecordCount()) then  
  enemyKilledByTotal=(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[pvpIdx]*1+1);  
 end 
 TF_setKilledCount((TF_getKilledCount()*1+1));  
 TF_setCurrentWinStreak(0); 
 TF_setClassKilledCount((TF_getClassKilledCount(tf_currentClass)*1+1),tf_currentClass);
 TF_setRaceKilledCount((TF_getRaceKilledCount(tf_currentRace)*1+1),tf_currentRace); 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[pvpIdx] = tf_currentTargetName;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyLvl[pvpIdx] = tf_currentTargetLvl;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyRace[pvpIdx] = tf_currentRace;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyClass[pvpIdx] = tf_currentClass;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyTotal[pvpIdx] = enemyKilledByTotal;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByYourLvl = tf_yourLvl;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByZone = tf_targetZone;
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByDate[pvpIdx] = date();  
end

function TF_addPvERecordWin()
 if(TF_getTargetType() == "pve") then
  TF_setTotalPveKills((TF_getTotalPveKills()*1+1));  
 elseif(TF_getTargetType() == "elitepve") then
  TF_setTotalPveEliteKills((TF_getTotalPveEliteKills()*1+1));
 end 
end

function TF_getTotalPveKills() 
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_wins;
end

function TF_setTotalPveKills(x) 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_wins=x;
end

function TF_getTotalPveEliteKills() 
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_wins;
end

function TF_setTotalPveEliteKills(x) 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_wins=x;
end

function TF_addPvERecordLoss()
 if(TF_getTargetType() == "pve") then
  TF_setTotalPveDeaths((TF_getTotalPveDeaths()*1+1));  
 elseif(TF_getTargetType() == "elitepve") then
  TF_setTotalPveEliteDeaths((TF_getTotalPveEliteDeaths()*1+1));
 end 
end

function TF_getTotalPveDeaths() 
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_loss;
end

function TF_setTotalPveDeaths(x) 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pve_loss=x;
end

function TF_getTotalPveEliteDeaths() 
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_loss;
end

function TF_setTotalPveEliteDeaths(x) 
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pveElite_loss=x;
end

function TF_getKillIndex()
 local idx=1; 
 do  
   if idx >= TF_getPvPKillsRecordCount() then end
   while(idx <= TF_getPvPKillsRecordCount()) do     
     if(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledEnemyName[idx] == tf_currentTargetName) then	 	 
	 return idx;	 
	end		   
	idx=(idx+1);
   end
 end 
 return idx
end

function TF_getKilledIndex()
 local idx=1; 
 do  
   if idx >= TF_getPvPLossRecordCount() then end
   while(idx <= TF_getPvPLossRecordCount()) do
    if(tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvpKilledByEnemyName[idx] == tf_currentTargetName) then	 
	 return idx;	 
	end		   
	idx=(idx+1);
   end
 end 
 return idx
end

function TF_setCurrentWinStreak(x)
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_current_win_streak=x;
end

function TF_getCurrentWinStreak()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_current_win_streak*1;
end

function TF_setLongestWinStreak(x)
 tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_longest_win_streak=x;
end

function TF_getLongestWinStreak()
 return tf_user_data[TF_getPlayerRealm()][TF_getPlayerName()].pvp_longest_win_streak*1;
end

function TF_DisplayToolTip(strTxt, pos)
 TFKillStatsTooltip:SetOwner(this, pos);
 TFKillStatsTooltip:SetText(strTxt, 1.0, 1.0, 1.0, 1.0);
 return;
end

function TF_HideToolTip()
 TFKillStatsTooltip:SetOwner(this, pos);
 TFKillStatsTooltip:SetText("");
 return;
end